// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

// ==========================================================================
// File:            TDirectDrawClipper.CPP
// Description:     This file contains the code for the TDirectDrawClipper
//                  component
//
// (c) 1998 A.S.C. Alternate Software Concepts, Sydney, Australia.
// All Rights Reserved. Refer to the file TDirectX_Licence.Txt for detailed
// licence & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// Include the TDirectDrawClipper H File
// --------------------------------------------------------------------------
#include "TDirectDrawClipper.h"

// --------------------------------------------------------------------------
static inline TDirectDrawClipper *ValidCtrCheck()
{
	return new TDirectDrawClipper(NULL);
}
// --------------------------------------------------------------------------
namespace Tdirectdrawclipper
{
	void __fastcall Register()
	{
		TComponentClass classes[1] = {__classid(TDirectDrawClipper)};
		RegisterComponents("DirectX", classes, 0);
	}
}

// --------------------------------------------------------------------------
// Method:          Constructor
// Description:     Sets the default values used within TDirectDraw and
//                  creates any miscellaneous internal objects
// --------------------------------------------------------------------------
                    __fastcall TDirectDrawClipper::TDirectDrawClipper
                                                        ( TComponent* Owner )
                                                        : TComponent( Owner )
{
fError = DD_OK;
}

// --------------------------------------------------------------------------
// Method:          Destructor
// Description:     Release / delete anything created in the constructor
// --------------------------------------------------------------------------
                    __fastcall  TDirectDraw::~TDirectDrawClipper()
{
}

// --------------------------------------------------------------------------
// Method:          GetClipList
// Description:     Retrieves a copy of the clip list associated with a
//                  DirectDrawClipper object
// Note:            A subset of the clip list can be selected by passing a
//                  rectangle that clips the clip list
// --------------------------------------------------------------------------
HRESULT             __fastcall  TDirectDrawClipper::GetClipList()
{
return fError;
//  LPRECT lpRect, LPRGNDATA lpClipList, LPDWORD lpdwSize
}

// --------------------------------------------------------------------------
// Method:          SetClipList
// Description:     Sets or deletes the clip list on surfaces to which the
//                  parent DirectDrawClipper object is attached
// Note:            The clip list Cannot be set if a window handle is already
//                  associated with the DirectDrawClipper object
//                  The BltFast method cannot clip
// --------------------------------------------------------------------------
HRESULT             __fastcall  TDirectDrawClipper::SetClipList()
{
return fError;
//LPRGNDATA lpClipList, DWORD dwFlags
}

// --------------------------------------------------------------------------
// Method:          GetHwnd
// Description:     Retrieves the window handle previously associated with
//                  this DirectDrawClipper object by the SetHWnd method
// --------------------------------------------------------------------------
HRESULT             __fastcall  TDirectDrawClipper::GetHWnd()
{
return fError;
//HWND FAR *lphWnd
}

// --------------------------------------------------------------------------
// Method:          SetHwnd
// Description:     Sets the window handle that will obtain the clipping
//                  information
// --------------------------------------------------------------------------
HRESULT             __fastcall  TDirectDrawClipper::SetHWnd()
{
return fError;
//DWORD dwFlags, HWND hWnd
}

// --------------------------------------------------------------------------
// Method:          IsClipListChanged
// Description:     Monitors the status of the clip list if a window handle
//                  is associated with a DirectDrawClipper object
// --------------------------------------------------------------------------
HRESULT             __fastcall  TDirectDrawClipper::IsClipListChanged()
{
return fError;
//BOOL FAR *lpbChanged
}

// --------------------------------------------------------------------------

