// --------------------------------------------------------------------------
#ifndef TDirectDrawClipperH
#define TDirectDrawClipperH

// ==========================================================================
// File:            TDirectDrawClipper.H
// Description:     This file contains the definition for the
//                  TDirectDrawClipper component
//
// (c) 1998 A.S.C. Alternate Software Concepts, Sydney, Australia.
// All Rights Reserved. Refer to the file TDirectX_Licence.Txt for detailed
// licence & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// include the BCB related definitions, etc.
// --------------------------------------------------------------------------
#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Forms.hpp>

// --------------------------------------------------------------------------
// include the basic TDirectDraw definitions, etc.
// --------------------------------------------------------------------------
#include "TDirectDrawInclude.h"
#include "TDirectDrawDefs.h"
#include "TDirectDrawErrors.h"

// ==========================================================================
//
// Class:           TDirectDrawClipper
//
// Description:     This is a component that wraps the functionality of the
//                  IDIRECTDRAWCLIPPER interface available within DirectX5
//
//                  All methods of this object attempt to call the relevant
//                  IDIRECTDRAWCLIPPER interface functions.
//
//                  All methods call the OnError event method if any errors
//                  are encountered during execution of the relevant DirectX
//                  functions
//
// Published
// Properties:
//
// Public
// Properties:
//
// Methods:
//
// Events:
//
// ==========================================================================
class TDirectDrawClipper : public TComponent
{
__published:

public:

// --------------------------------------------------------------------------
// Property:        ErrorValue
// Description:
// --------------------------------------------------------------------------
    __property	    int                  ErrorValue = { read=fError,
                                                        write=fError,
                                                        default=DD_OK };
  //__property	AnsiString	ErrorMessage = {read=GetErrorMessage};

// --------------------------------------------------------------------------
// Constructor & Destructor
// --------------------------------------------------------------------------
	                __fastcall TDirectDrawClipper(TComponent* Owner);
    virtual			__fastcall	~TDirectDrawClipper();

protected:

    virtual HRESULT __fastcall  GetClipList();
    virtual HRESULT __fastcall  SetClipList();
    virtual HRESULT __fastcall  IsClipListChanged();
    virtual HRESULT __fastcall  GetHWnd();
    virtual HRESULT __fastcall  SetHWnd();

private:

	int			    fError;
};
// --------------------------------------------------------------------------
#endif



