//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

// ==========================================================================
// File:            TDDBltBatchPropertyEditor.CPP
// Description:     This file contains the code for the property editor
//                  used to edit TDDBltBatch type properties of the
//                  various components in the TDirectX library.
//
// (c) 1998 A.S.C. Alternate Software Concepts, Sydney, Australia.
// All Rights Reserved. Refer to the file TDirectX_Licence.Txt for detailed
// licence & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// include the various TDDBltBatch classes.
// --------------------------------------------------------------------------
#include "TDDBltBatchPropertyEditor.h"
#include "TDDBltBatch.h"
#include "TDDBltBatchEditor.h"

//---------------------------------------------------------------------------
// Method:          GetValue()
// Description:     This method returns the string that the object
//                  inspector displays next to the property name.
//---------------------------------------------------------------------------
AnsiString          __fastcall      TDDBltBatchPropertyEditor::GetValue()
{
// retrieve a pointer to the property that the object inspector is using.
TDDBltBatch* ddbltbatch = (TDDBltBatch*) GetOrdValue();

// return a string for the object inspector to display
//return To_TDDBltBatchString( tddtemplate->Caps );
return"";
}

//---------------------------------------------------------------------------
// Method:          SetValue()
// Description:     This method sets the TDDBltBatch's internal values
//                  by parsing the string as required.
//---------------------------------------------------------------------------
void                __fastcall      TDDBltBatchPropertyEditor::SetValue(
                                                        AnsiString pValue )
{
// retrieve a pointer to the property that the object inspector is using.
TDDBltBatch* ddbltbatch = (TDDBltBatch*) GetOrdValue();

// set the relevant parameters based on what the object inspector supplied.
//ddtemplate->Caps = From_TDDBltBatchString( pValue );
}

//---------------------------------------------------------------------------
// Method:          GetAttributes()
// Description:     This method returns the attributes that tell the
//                  object inspector what functions to perform when
//                  editing the TDDBltBatch property
//---------------------------------------------------------------------------
TPropertyAttributes __fastcall      TDDBltBatchPropertyEditor::GetAttributes
                                                                        ()
{
// we want to open a dialog & the property should stay intact if unchanged
return TPropertyAttributes() << paDialog << paRevertable;
}

//---------------------------------------------------------------------------
// Method:          Edit()
// Description:     This method opens a custom TDDBltBatch
//                  dialog box editor which is used to modify the various
//                  properties of the TDDBltBatch class.
//---------------------------------------------------------------------------
void                __fastcall      TDDBltBatchPropertyEditor::Edit()
{
// try creating the editor
TDDBltBatchEditor* editor = new TDDBltBatchEditor(Application);
if (editor==NULL) return;

// get a pointer to the property the object inspector is talking about
TDDBltBatch* ddbltbatch = (TDDBltBatch*) GetOrdValue();

// setup the default values used by the editor
 editor->SCaps->Caps = caps->Caps;

// if the dialog was clicked OK.... update the appropriate values, then tell
// the designer that the values have changed
if (editor->ShowModal() == ID_OK)
    {
    // caps->Caps = editor->SCaps->Caps;
    Designer->Modified();
    }
delete editor;
}
//---------------------------------------------------------------------------

