//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

// ==========================================================================
// File:            TDDCapsPropertyEditor.CPP
// Description:     This file contains the code for the property editor
//                  used to edit TDDCaps type properties of the various
//                  components in the TDirectX library.
//
// (c) 1998 A.S.C. Alternate Software Concepts, Sydney, Australia.
// All Rights Reserved. Refer to the file TDirectX_Licence.Txt for detailed
// licence & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// include the various TDDCaps classes.
// --------------------------------------------------------------------------
#include "TDDCapsPropertyEditor.h"
#include "TDDCaps.h"
#include "TDDCapsEditor.h"

//---------------------------------------------------------------------------
// Method:          GetValue()
// Description:     This method returns the string that the object
//                  inspector displays next to the property name.
//---------------------------------------------------------------------------
AnsiString          __fastcall      TDDCapsPropertyEditor::GetValue()
{
// retrieve a pointer to the property that the object inspector is using.
TDDCaps* caps = (TDDCaps*) GetOrdValue();

// return a string for the object inspector to display
//return To_TDDCapsString( tcaps->Caps );
return "";
}

//---------------------------------------------------------------------------
// Method:          SetValue()
// Description:     This method sets the TDDCaps's internal values
//                  by parsing the string as required.
//---------------------------------------------------------------------------
void                __fastcall      TDDCapsPropertyEditor::SetValue(
                                                        AnsiString pValue )
{
// retrieve a pointer to the property that the object inspector is using.
TDDCaps* caps = (TDDCaps*) GetOrdValue();

// set the relevant parameters based on what the object inspector supplied.
//caps->Caps = From_TDDCapsString( pValue );
}

//---------------------------------------------------------------------------
// Method:          GetAttributes()
// Description:     This method returns the attributes that tell the
//                  object inspector what functions to perform when
//                  editing the TDDCaps property
//---------------------------------------------------------------------------
TPropertyAttributes __fastcall      TDDCapsPropertyEditor::GetAttributes()
{
// we want to open a dialog & the property should stay intact if unchanged
return TPropertyAttributes() << paDialog << paRevertable;
}

//---------------------------------------------------------------------------
// Method:          Edit()
// Description:     This method opens a custom TDDCaps
//                  dialog box editor which is used to modify the various
//                  properties of the TDDCaps class.
//---------------------------------------------------------------------------
void                __fastcall      TDDCapsPropertyEditor::Edit()
{
// try creating the editor
TDDCapsEditor* editor = new TDDCapsEditor(Application);
if (editor==NULL) return;

// get a pointer to the property the object inspector is talking about
TDDCaps* caps = (TDDCaps*) GetOrdValue();

// setup the default values used by the editor
// editor->SCaps->Caps = caps->Caps;

// if the dialog was clicked OK.... update the appropriate values, then tell
// the designer that the values have changed
if (editor->ShowModal() == ID_OK)
    {
    // caps->Caps = editor->SCaps->Caps;
    Designer->Modified();
    }
delete editor;
}
//---------------------------------------------------------------------------

