//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

// ==========================================================================
// File:            TDDColorControlPropertyEditor.CPP
// Description:     This file contains the code for the property editor
//                  used to edit TDDColorControl type properties of the
//                  various components in the TDirectX library.
//
// (c) 1998 A.S.C. Alternate Software Concepts, Sydney, Australia.
// All Rights Reserved. Refer to the file TDirectX_Licence.Txt for detailed
// licence & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// include the various TDDColorControl classes.
// --------------------------------------------------------------------------
#include "TDDColorControlPropertyEditor.h"
#include "TDDColorControl.h"
#include "TDDColorControlEditor.h"

//---------------------------------------------------------------------------
// Method:          GetValue()
// Description:     This method returns the string that the object
//                  inspector displays next to the property name.
//---------------------------------------------------------------------------
AnsiString          __fastcall      TDDColorControlPropertyEditor::GetValue()
{
// retrieve a pointer to the property that the object inspector is using.
TDDColorControl* colorcontrol = (TDDColorControl*) GetOrdValue();

// return a string for the object inspector to display
//return To_TDDColorControlString( tcolorcontrol->Caps );
return "";
}

//---------------------------------------------------------------------------
// Method:          SetValue()
// Description:     This method sets the TDDColorControl's internal values
//                  by parsing the string as required.
//---------------------------------------------------------------------------
void                __fastcall      TDDColorControlPropertyEditor::SetValue(
                                                        AnsiString pValue )
{
// retrieve a pointer to the property that the object inspector is using.
TDDColorControl* colorcontrol = (TDDColorControl*) GetOrdValue();

// set the relevant parameters based on what the object inspector supplied.
//colorcontrol->Caps = From_TDDColorControlString( pValue );
}

//---------------------------------------------------------------------------
// Method:          GetAttributes()
// Description:     This method returns the attributes that tell the
//                  object inspector what functions to perform when
//                  editing the TDDColorControl property
//---------------------------------------------------------------------------
TPropertyAttributes __fastcall      TDDColorControlPropertyEditor::
                                                            GetAttributes()
{
// we want to open a dialog & the property should stay intact if unchanged
return TPropertyAttributes() << paDialog << paRevertable;
}

//---------------------------------------------------------------------------
// Method:          Edit()
// Description:     This method opens a custom TDDColorControl
//                  dialog box editor which is used to modify the various
//                  properties of the TDDColorControl class.
//---------------------------------------------------------------------------
void                __fastcall      TDDColorControlPropertyEditor::Edit()
{
// try creating the editor
TDDColorControlEditor* editor = new TDDColorControlEditor(Application);
if (editor==NULL) return;

// get a pointer to the property the object inspector is talking about
TDDColorControl* colorcontrol = (TDDColorControl*) GetOrdValue();

// setup the default values used by the editor
// editor->SCaps->Caps = caps->Caps;

// if the dialog was clicked OK.... update the appropriate values, then tell
// the designer that the values have changed
if (editor->ShowModal() == ID_OK)
    {
    // caps->Caps = editor->SCaps->Caps;
    Designer->Modified();
    }
delete editor;
}
//---------------------------------------------------------------------------

