//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

// ==========================================================================
// File:            TDDColorKeyPropertyEditor.CPP
// Description:     This file contains the code for the property editor
//                  used to edit TDDColorKey type properties of the
//                  various components in the TDirectX library.
//
// (c) 1998 A.S.C. Alternate Software Concepts, Sydney, Australia.
// All Rights Reserved. Refer to the file TDirectX_Licence.Txt for detailed
// licence & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// include the various TDDColorKey classes.
// --------------------------------------------------------------------------
#include "TDDColorKeyPropertyEditor.h"
#include "TDDColorKey.h"
#include "TDDColorKeyEditor.h"

//---------------------------------------------------------------------------
// Method:          GetValue()
// Description:     This method returns the string that the object
//                  inspector displays next to the property name.
//---------------------------------------------------------------------------
AnsiString          __fastcall      TDDColorKeyPropertyEditor::GetValue()
{
// retrieve a pointer to the property that the object inspector is using.
TDDColorKey* colorkey = (TDDColorKey*) GetOrdValue();

// return a string for the object inspector to display
//return To_TDDColorKeyString( tcolorkey->Caps );
return "";
}

//---------------------------------------------------------------------------
// Method:          SetValue()
// Description:     This method sets the TDDColorKey's internal values
//                  by parsing the string as required.
//---------------------------------------------------------------------------
void                __fastcall      TDDColorKeyPropertyEditor::SetValue(
                                                        AnsiString pValue )
{
// retrieve a pointer to the property that the object inspector is using.
TDDColorKey* colorkey = (TDDColorKey*) GetOrdValue();

// set the relevant parameters based on what the object inspector supplied.
//colorkey->Caps = From_TDDColorKeyString( pValue );
}

//---------------------------------------------------------------------------
// Method:          GetAttributes()
// Description:     This method returns the attributes that tell the
//                  object inspector what functions to perform when
//                  editing the TDDColorKey property
//---------------------------------------------------------------------------
TPropertyAttributes __fastcall      TDDColorKeyPropertyEditor::GetAttributes
                                                                        ()
{
// we want to open a dialog & the property should stay intact if unchanged
return TPropertyAttributes() << paDialog << paRevertable;
}

//---------------------------------------------------------------------------
// Method:          Edit()
// Description:     This method opens a custom TDDColorKey
//                  dialog box editor which is used to modify the various
//                  properties of the TDDColorKey class.
//---------------------------------------------------------------------------
void                __fastcall      TDDColorKeyPropertyEditor::Edit()
{
// try creating the editor
TDDColorKeyEditor* editor = new TDDColorKeyEditor(Application);
if (editor==NULL) return;

// get a pointer to the property the object inspector is talking about
TDDColorKey* colorkey = (TDDColorKey*) GetOrdValue();

// setup the default values used by the editor
// editor->SCaps->Caps = caps->Caps;

// if the dialog was clicked OK.... update the appropriate values, then tell
// the designer that the values have changed
if (editor->ShowModal() == ID_OK)
    {
    // caps->Caps = editor->SCaps->Caps;
    Designer->Modified();
    }
delete editor;
}
//---------------------------------------------------------------------------

