//---------------------------------------------------------------------------
#ifndef TDDColorKeyPropertyEditorH
#define TDDColorKeyPropertyEditorH

// ==========================================================================
// File:            TDDColorKeyPropertyEditor.H
// Description:     This file contains the definition for the property editor
//                  used to edit TDDColorKey type properties of the
//                  various components in the TDirectX library.
//
// (c) 1998 A.S.C. Alternate Software Concepts, Sydney, Australia.
// All Rights Reserved. Refer to the file TDirectX_Licence.Txt for detailed
// licence & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// include the VCL definition for a TProperyEditor
// --------------------------------------------------------------------------
#include "dsgnintf.hpp"

// ==========================================================================
// Class:           TDDColorKeyPropertyEditor
// Description:     This property editor uses the TDDColorKeyEditor to edit
//                  the various parameters of a TDDColorKey property.
// ==========================================================================
class TDDColorKeyPropertyEditor : public TPropertyEditor
{
__published:
public:

// --------------------------------------------------------------------------
// Method:          GetValue()
// Description:     This method returns the string that the object
//                  inspector displays next to the property name.
// --------------------------------------------------------------------------
    virtual AnsiString          __fastcall  GetValue();

// --------------------------------------------------------------------------
// Method:          SetValue()
// Description:     This method sets the TDDColorKey's internal values
//                  by parsing the string as required.
// --------------------------------------------------------------------------
    virtual void                __fastcall  SetValue( AnsiString pValue );

// --------------------------------------------------------------------------
// Method:          GetAttributes()
// Description:     This method returns the attributes that tell the
//                  object inspector what functions to perform when
//                  editing the TDDColorKey property
// --------------------------------------------------------------------------
    virtual TPropertyAttributes __fastcall  GetAttributes();

// --------------------------------------------------------------------------
// Method:          Edit()
// Description:     This method opens a custom TDDColorKey dialog box
//                  editor which is used to modify the various properties
//                  of the TDDColorKey class.
// --------------------------------------------------------------------------
    virtual void                __fastcall  Edit();

// --------------------------------------------------------------------------
// Method:          Constructor
// --------------------------------------------------------------------------
    __fastcall  TDDColorKeyPropertyEditor() : TPropertyEditor() {}

protected:
private:
};
//---------------------------------------------------------------------------
#endif
