//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

// ==========================================================================
// File:            TDDPixelFormatPropertyEditor.CPP
// Description:     This file contains the code for the property editor
//                  used to edit TDDPixelFormat type properties of the
//                  various components in the TDirectX library.
//
// (c) 1998 A.S.C. Alternate Software Concepts, Sydney, Australia.
// All Rights Reserved. Refer to the file TDirectX_Licence.Txt for detailed
// licence & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// include the various TDDPixelFormat classes.
// --------------------------------------------------------------------------
#include "TDDPixelFormatPropertyEditor.h"
#include "TDDPixelFormat.h"
#include "TDDPixelFormatEditor.h"

//---------------------------------------------------------------------------
// Method:          GetValue()
// Description:     This method returns the string that the object
//                  inspector displays next to the property name.
//---------------------------------------------------------------------------
AnsiString          __fastcall      TDDPixelFormatPropertyEditor::GetValue()
{
// retrieve a pointer to the property that the object inspector is using.
TDDPixelFormat* pixelformat = (TDDPixelFormat*) GetOrdValue();

// return a string for the object inspector to display
//return To_TDDPixelFormatString( tpixelformat->Caps );
return "";
}

//---------------------------------------------------------------------------
// Method:          SetValue()
// Description:     This method sets the TDDPixelFormat's internal values
//                  by parsing the string as required.
//---------------------------------------------------------------------------
void                __fastcall      TDDPixelFormatPropertyEditor::SetValue(
                                                        AnsiString pValue )
{
// retrieve a pointer to the property that the object inspector is using.
TDDPixelFormat* pixelformat = (TDDPixelFormat*) GetOrdValue();

// set the relevant parameters based on what the object inspector supplied.
//pixelformat->Caps = From_TDDPixelFormatString( pValue );
}

//---------------------------------------------------------------------------
// Method:          GetAttributes()
// Description:     This method returns the attributes that tell the
//                  object inspector what functions to perform when
//                  editing the TDDPixelFormat property
//---------------------------------------------------------------------------
TPropertyAttributes __fastcall      TDDPixelFormatPropertyEditor::
                                                            GetAttributes()
{
// we want to open a dialog & the property should stay intact if unchanged
return TPropertyAttributes() << paDialog << paRevertable;
}

//---------------------------------------------------------------------------
// Method:          Edit()
// Description:     This method opens a custom TDDPixelFormat
//                  dialog box editor which is used to modify the various
//                  properties of the TDDPixelFormat class.
//---------------------------------------------------------------------------
void                __fastcall      TDDPixelFormatPropertyEditor::Edit()
{
// try creating the editor
TDDPixelFormatEditor* editor = new TDDPixelFormatEditor(Application);
if (editor==NULL) return;

// get a pointer to the property the object inspector is talking about
TDDPixelFormat* pixelformat = (TDDPixelFormat*) GetOrdValue();

// setup the default values used by the editor
// editor->SCaps->Caps = caps->Caps;

// if the dialog was clicked OK.... update the appropriate values, then tell
// the designer that the values have changed
if (editor->ShowModal() == ID_OK)
    {
    // caps->Caps = editor->SCaps->Caps;
    Designer->Modified();
    }
delete editor;
}
//---------------------------------------------------------------------------

