//---------------------------------------------------------------------------
#ifndef TDDSCapsPropertyEditorH
#define TDDSCapsPropertyEditorH

// ==========================================================================
// File:            TDDSCapsPropertyEditor.H
// Description:     This file contains the definition for the property editor
//                  used to edit TDDSCaps type properties of the
//                  various components in the TDirectX library.
//
// (c) 1998 A.S.C. Alternate Software Concepts, Sydney, Australia.
// All Rights Reserved. Refer to the file TDirectX_Licence.Txt for detailed
// licence & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// include the VCL definition for a TProperyEditor
// --------------------------------------------------------------------------
#include "dsgnintf.hpp"

// ==========================================================================
// Class:           TDDSCapsPropertyEditor
// Description:     This property editor uses the TDDSCapsEditor to edit
//                  the various parameters of a TDDSCaps property.
// ==========================================================================
class TDDSCapsPropertyEditor : public TPropertyEditor
{
__published:
public:

                                __fastcall      TDDSCapsPropertyEditor();

//---------------------------------------------------------------------------
// Method:          GetValue()
// Description:     This method returns the string that the object
//                  inspector displays next to the property name.
//---------------------------------------------------------------------------
    virtual AnsiString          __fastcall  GetValue();

//---------------------------------------------------------------------------
// Method:          SetValue()
// Description:     This method sets the TDDSCaps's internal values
//                  by parsing the string as required.
//---------------------------------------------------------------------------
    virtual void                __fastcall  SetValue( AnsiString value );

//---------------------------------------------------------------------------
// Method:          GetAttributes()
// Description:     This method returns the attributes that tell the
//                  object inspector what functions to perform when
//                  editing the TDDSCaps property
//---------------------------------------------------------------------------
    virtual TPropertyAttributes __fastcall  GetAttributes();

//---------------------------------------------------------------------------
// Method:          Edit()
// Description:     This method opens a custom TDDSCaps dialog box
//                  editor which is used to modify the various properties
//                  of the TDDSCaps class.
//---------------------------------------------------------------------------
    virtual void                    __fastcall  Edit();

protected:
private:
};
//---------------------------------------------------------------------------
#endif
