//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

// ==========================================================================
// File:            TDDSurfaceDescPropertyEditor.CPP
// Description:     This file contains the code for the property editor
//                  used to edit TDDSurfaceDesc type properties of the
//                  various components in the TDirectX library.
//
// (c) 1998 A.S.C. Alternate Software Concepts, Sydney, Australia.
// All Rights Reserved. Refer to the file TDirectX_Licence.Txt for detailed
// licence & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// include the various TDDSurfaceDesc classes.
// --------------------------------------------------------------------------
#include "TDDSurfaceDescPropertyEditor.h"
#include "TDDSurfaceDesc.h"
#include "TDDSurfaceDescEditor.h"

//---------------------------------------------------------------------------
__fastcall      TDDSurfaceDescPropertyEditor::TDDSurfaceDescPropertyEditor()
    : TPropertyEditor()
{
}

//---------------------------------------------------------------------------
// Method:          GetValue()
// Description:     This method returns the string that the object
//                  inspector displays next to the property name.
//---------------------------------------------------------------------------
AnsiString          __fastcall  TDDSurfaceDescPropertyEditor::GetValue()
{
// retrieve a pointer to the property that the object inspector is using.
TDDSurfaceDesc* desc = (TDDSurfaceDesc*) GetOrdValue();

// return a string for the object inspector to display
//return To_TDDSurfaceDescString( tddsurfacedesc->Caps );
return"";//To_TDDSurfaceDescString( desc );
}

//---------------------------------------------------------------------------
// Method:          SetValue()
// Description:     This method sets the TDDSurfaceDesc's internal values
//                  by parsing the string as required.
//---------------------------------------------------------------------------
void                    __fastcall  TDDSurfaceDescPropertyEditor::SetValue(
                                                        AnsiString value )
{
// retrieve a pointer to the property that the object inspector is using.
TDDSurfaceDesc* desc = (TDDSurfaceDesc*) GetOrdValue();

// set the relevant parameters based on what the object inspector supplied.
//desc->Ptr() = (LPDDSURFACEDESC) StrToInt(value);
}

//---------------------------------------------------------------------------
// Method:          GetAttributes()
// Description:     This method returns the attributes that tell the
//                  object inspector what functions to perform when
//                  editing the TDDSurfaceDesc property
//---------------------------------------------------------------------------
TPropertyAttributes     __fastcall  TDDSurfaceDescPropertyEditor::
                                                            GetAttributes()
{
// we want to open a dialog & the property should stay intact if unchanged
return TPropertyAttributes() << paDialog << paRevertable;
}

//---------------------------------------------------------------------------
// Method:          Edit()
// Description:     This method opens a custom TDDSurfaceDesc
//                  dialog box editor which is used to modify the various
//                  properties of the TDDSurfaceDesc class.
//---------------------------------------------------------------------------
void                    __fastcall  TDDSurfaceDescPropertyEditor::Edit()
{
// try creating the editor
TDDSurfaceDescEditor* editor = new TDDSurfaceDescEditor(Application);
if (editor==NULL) return;

// get a pointer to the property the object inspector is talking about
TDDSurfaceDesc* srce = (TDDSurfaceDesc*) GetOrdValue();
TDDSurfaceDesc* dest = editor->Description;

// setup the default values used by the editor
dest->Flags = srce->Flags;
dest->Height = srce->Height;
dest->Width = srce->Width;
dest->Pitch = srce->Pitch;
dest->BackBufferCount = srce->BackBufferCount;
dest->MipMapCount = srce->MipMapCount;
dest->ZBufferBitDepth = srce->ZBufferBitDepth;
dest->RefreshRate = srce->RefreshRate;
dest->AlphaBitDepth = srce->AlphaBitDepth;
dest->CKDestOverlay = srce->CKDestOverlay;
dest->CKDestBlt = srce->CKDestBlt;
dest->CKSrcOverlay = srce->CKSrcOverlay;
dest->CKSrcBlt = srce->CKSrcBlt;
dest->PixelFormat = srce->PixelFormat;
dest->SCaps->Caps = srce->SCaps->Caps;

// if the dialog was clicked OK.... update the appropriate values, then tell
// the designer that the values have changed
if (editor->ShowModal() == mrOk)
    {
    dest = (TDDSurfaceDesc*) GetOrdValue();
    srce = editor->Description;

    dest->Flags = srce->Flags;
    dest->Height = srce->Height;
    dest->Width = srce->Width;
    dest->Pitch = srce->Pitch;
    dest->BackBufferCount = srce->BackBufferCount;
    dest->MipMapCount = srce->MipMapCount;
    dest->ZBufferBitDepth = srce->ZBufferBitDepth;
    dest->RefreshRate = srce->RefreshRate;
    dest->AlphaBitDepth = srce->AlphaBitDepth;
    dest->CKDestOverlay = srce->CKDestOverlay;
    dest->CKDestBlt = srce->CKDestBlt;
    dest->CKSrcOverlay = srce->CKSrcOverlay;
    dest->CKSrcBlt = srce->CKSrcBlt;
    dest->PixelFormat = srce->PixelFormat;
    dest->SCaps->Caps = srce->SCaps->Caps;
    
    Designer->Modified();
    }
delete editor;
}
//---------------------------------------------------------------------------

