//---------------------------------------------------------------------------
#ifndef TDDTemplatePropertyEditorH
#define TDDTemplatePropertyEditorH

// ==========================================================================
// File:            TDDTemplatePropertyEditor.H
// Description:     This file contains the definition for the property editor
//                  used to edit TDDTemplate type properties of the
//                  various components in the TDirectX library.
//
// (c) 1998 A.S.C. Alternate Software Concepts, Sydney, Australia.
// All Rights Reserved. Refer to the file TDirectX_Licence.Txt for detailed
// licence & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// include the VCL definition for a TProperyEditor
// --------------------------------------------------------------------------
#include "dsgnintf.hpp"

// ==========================================================================
// Class:           TDDTemplatePropertyEditor
// Description:     This property editor uses the TDDTemplateEditor to edit
//                  the various parameters of a TDDTemplate property.
// ==========================================================================
class TDDTemplatePropertyEditor : public TPropertyEditor
{
__published:
public:

//---------------------------------------------------------------------------
// Method:          GetValue()
// Description:     This method returns the string that the object
//                  inspector displays next to the property name.
//---------------------------------------------------------------------------
    virtual AnsiString          __fastcall  GetValue();

//---------------------------------------------------------------------------
// Method:          SetValue()
// Description:     This method sets the TDDTemplate's internal values
//                  by parsing the string as required.
//---------------------------------------------------------------------------
    virtual void                __fastcall  SetValue( AnsiString pValue );

//---------------------------------------------------------------------------
// Method:          GetAttributes()
// Description:     This method returns the attributes that tell the
//                  object inspector what functions to perform when
//                  editing the TDDTemplate property
//---------------------------------------------------------------------------
    virtual TPropertyAttributes __fastcall  GetAttributes();

//---------------------------------------------------------------------------
// Method:          Edit()
// Description:     This method opens a custom TDDTemplate dialog box
//                  editor which is used to modify the various properties
//                  of the TDDTemplate class.
//---------------------------------------------------------------------------
    virtual void                __fastcall  Edit();

//---------------------------------------------------------------------------
// Method:          Constructor
//---------------------------------------------------------------------------
    __fastcall  TDDTemplatePropertyEditor() : TPropertyEditor() {}

protected:
private:
};
//---------------------------------------------------------------------------
#endif
