//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

// ==========================================================================
// File:            TDDVideoPortBandwidthPropertyEditor.CPP
// Description:     This file contains the code for the property editor
//                  used to edit TDDVideoPortBandwidth type properties of the
//                  various components in the TDirectX library.
//
// (c) 1998 A.S.C. Alternate Software Concepts, Sydney, Australia.
// All Rights Reserved. Refer to the file TDirectX_Licence.Txt for detailed
// licence & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// include the various TDDVideoPortBandwidth classes.
// --------------------------------------------------------------------------
#include "TDDVideoPortBandwidthPropertyEditor.h"
#include "TDDVideoPortBandwidth.h"
#include "TDDVideoPortBandwidthEditor.h"

//---------------------------------------------------------------------------
// Method:          GetValue()
// Description:     This method returns the string that the object
//                  inspector displays next to the property name.
//---------------------------------------------------------------------------
AnsiString          __fastcall      TDDVideoPortBandwidthPropertyEditor::
                                                                GetValue()
{
// retrieve a pointer to the property that the object inspector is using.
TDDVideoPortBandwidth* videoportbandwidth = (TDDVideoPortBandwidth*)
                                                            GetOrdValue();

// return a string for the object inspector to display
//return To_TDDVideoPortBandwidthString( tvideoportbandwidth->Caps );
return "";
}

//---------------------------------------------------------------------------
// Method:          SetValue()
// Description:     This method sets the TDDVideoPortBandwidth's internal
//                  values by parsing the string as required.
//---------------------------------------------------------------------------
void                __fastcall      TDDVideoPortBandwidthPropertyEditor::
                                                SetValue(AnsiString pValue )
{
// retrieve a pointer to the property that the object inspector is using.
TDDVideoPortBandwidth* videoportbandwidth = (TDDVideoPortBandwidth*)
                                                            GetOrdValue();

// set the relevant parameters based on what the object inspector supplied.
//videoportbandwidth->Caps = From_TDDVideoPortBandwidthString( pValue );
}

//---------------------------------------------------------------------------
// Method:          GetAttributes()
// Description:     This method returns the attributes that tell the
//                  object inspector what functions to perform when
//                  editing the TDDVideoPortBandwidth property
//---------------------------------------------------------------------------
TPropertyAttributes __fastcall      TDDVideoPortBandwidthPropertyEditor::
                                                            GetAttributes()
{
// we want to open a dialog & the property should stay intact if unchanged
return TPropertyAttributes() << paDialog << paRevertable;
}

//---------------------------------------------------------------------------
// Method:          Edit()
// Description:     This method opens a custom TDDVideoPortBandwidth
//                  dialog box editor which is used to modify the various
//                  properties of the TDDVideoPortBandwidth class.
//---------------------------------------------------------------------------
void                __fastcall      TDDVideoPortBandwidthPropertyEditor::
                                                                    Edit()
{
// try creating the editor
TDDVideoPortBandwidthEditor* editor = new TDDVideoPortBandwidthEditor
                                                            (Application);
if (editor==NULL) return;

// get a pointer to the property the object inspector is talking about
TDDVideoPortBandwidth* videoportbandwidth = (TDDVideoPortBandwidth*)
                                                            GetOrdValue();

// setup the default values used by the editor
// editor->SCaps->Caps = caps->Caps;

// if the dialog was clicked OK.... update the appropriate values, then tell
// the designer that the values have changed
if (editor->ShowModal() == ID_OK)
    {
    // caps->Caps = editor->SCaps->Caps;
    Designer->Modified();
    }
delete editor;
}
//---------------------------------------------------------------------------

