//---------------------------------------------------------------------------
#ifndef TDDVideoPortBandwidthPropertyEditorH
#define TDDVideoPortBandwidthPropertyEditorH

// ==========================================================================
// File:            TDDVideoPortBandwidthPropertyEditor.H
// Description:     This file contains the definition for the property editor
//                  used to edit TDDVideoPortBandwidth type properties of the
//                  various components in the TDirectX library.
//
// (c) 1998 A.S.C. Alternate Software Concepts, Sydney, Australia.
// All Rights Reserved. Refer to the file TDirectX_Licence.Txt for detailed
// licence & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// include the VCL definition for a TProperyEditor
// --------------------------------------------------------------------------
#include "dsgnintf.hpp"

// ==========================================================================
// Class:           TDDVideoPortBandwidthPropertyEditor
// Description:     This property editor uses the TDDVideoPortBandwidthEditor
//                  to edit the various parameters of a TDDVideoPortBandwidth
//                  property.
// ==========================================================================
class TDDVideoPortBandwidthPropertyEditor : public TPropertyEditor
{
__published:
public:

// --------------------------------------------------------------------------
// Method:          GetValue()
// Description:     This method returns the string that the object
//                  inspector displays next to the property name.
// --------------------------------------------------------------------------
    virtual AnsiString          __fastcall  GetValue();

// --------------------------------------------------------------------------
// Method:          SetValue()
// Description:     This method sets the TDDVideoPortBandwidth's internal
//                  values by parsing the string as required.
// --------------------------------------------------------------------------
    virtual void                __fastcall  SetValue( AnsiString pValue );

// --------------------------------------------------------------------------
// Method:          GetAttributes()
// Description:     This method returns the attributes that tell the
//                  object inspector what functions to perform when
//                  editing the TDDVideoPortBandwidth property
// --------------------------------------------------------------------------
    virtual TPropertyAttributes __fastcall  GetAttributes();

// --------------------------------------------------------------------------
// Method:          Edit()
// Description:     This method opens a custom TDDVideoPortBandwidth dialog
//                  box editor which is used to modify the various properties
//                  of the TDDVideoPortBandwidth class.
//---------------------------------------------------------------------------
    virtual void                __fastcall  Edit();

//---------------------------------------------------------------------------
// Method:          Constructor
//---------------------------------------------------------------------------
    __fastcall  TDDVideoPortBandwidthPropertyEditor() : TPropertyEditor() {}

protected:
private:
};
//---------------------------------------------------------------------------
#endif
