//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

// ==========================================================================
// File:            TDDVideoPortConnectPropertyEditor.CPP
// Description:     This file contains the code for the property editor
//                  used to edit TDDVideoPortConnect type properties of the
//                  various components in the TDirectX library.
//
// (c) 1998 A.S.C. Alternate Software Concepts, Sydney, Australia.
// All Rights Reserved. Refer to the file TDirectX_Licence.Txt for detailed
// licence & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// include the various TDDVideoPortConnect classes.
// --------------------------------------------------------------------------
#include "TDDVideoPortConnectPropertyEditor.h"
#include "TDDVideoPortConnect.h"
#include "TDDVideoPortConnectEditor.h"

//---------------------------------------------------------------------------
// Method:          GetValue()
// Description:     This method returns the string that the object
//                  inspector displays next to the property name.
//---------------------------------------------------------------------------
AnsiString          __fastcall      TDDVideoPortConnectPropertyEditor::
                                                                GetValue()
{
// retrieve a pointer to the property that the object inspector is using.
TDDVideoPortConnect* videoportconnect = (TDDVideoPortConnect*) GetOrdValue();

// return a string for the object inspector to display
//return To_TDDVideoPortConnectString( tvideoportconnect->Caps );
return "";
}

//---------------------------------------------------------------------------
// Method:          SetValue()
// Description:     This method sets the TDDVideoPortConnect's internal
//                  values by parsing the string as required.
//---------------------------------------------------------------------------
void                __fastcall      TDDVideoPortConnectPropertyEditor::
                                                SetValue( AnsiString pValue )
{
// retrieve a pointer to the property that the object inspector is using.
TDDVideoPortConnect* videoportconnect = (TDDVideoPortConnect*) GetOrdValue();

// set the relevant parameters based on what the object inspector supplied.
//videoportconnect->Caps = From_TDDVideoPortConnectString( pValue );
}

//---------------------------------------------------------------------------
// Method:          GetAttributes()
// Description:     This method returns the attributes that tell the
//                  object inspector what functions to perform when
//                  editing the TDDVideoPortConnect property
//---------------------------------------------------------------------------
TPropertyAttributes __fastcall      TDDVideoPortConnectPropertyEditor::
                                                            GetAttributes()
{
// we want to open a dialog & the property should stay intact if unchanged
return TPropertyAttributes() << paDialog << paRevertable;
}

//---------------------------------------------------------------------------
// Method:          Edit()
// Description:     This method opens a custom TDDVideoPortConnect
//                  dialog box editor which is used to modify the various
//                  properties of the TDDVideoPortConnect class.
//---------------------------------------------------------------------------
void                __fastcall      TDDVideoPortConnectPropertyEditor::Edit()
{
// try creating the editor
TDDVideoPortConnectEditor* editor = new TDDVideoPortConnectEditor
                                                            (Application);
if (editor==NULL) return;

// get a pointer to the property the object inspector is talking about
TDDVideoPortConnect* videoportconnect = (TDDVideoPortConnect*) GetOrdValue();

// setup the default values used by the editor
// editor->SCaps->Caps = caps->Caps;

// if the dialog was clicked OK.... update the appropriate values, then tell
// the designer that the values have changed
if (editor->ShowModal() == ID_OK)
    {
    // caps->Caps = editor->SCaps->Caps;
    Designer->Modified();
    }
delete editor;
}
//---------------------------------------------------------------------------

