//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

// ==========================================================================
// File:            TDDVideoPortInfoPropertyEditor.CPP
// Description:     This file contains the code for the property editor
//                  used to edit TDDVideoPortInfo type properties of the
//                  various components in the TDirectX library.
//
// (c) 1998 A.S.C. Alternate Software Concepts, Sydney, Australia.
// All Rights Reserved. Refer to the file TDirectX_Licence.Txt for detailed
// licence & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// include the various TDDVideoPortInfo classes.
// --------------------------------------------------------------------------
#include "TDDVideoPortInfoPropertyEditor.h"
#include "TDDVideoPortInfo.h"
#include "TDDVideoPortInfoEditor.h"

//---------------------------------------------------------------------------
// Method:          GetValue()
// Description:     This method returns the string that the object
//                  inspector displays next to the property name.
//---------------------------------------------------------------------------
AnsiString          __fastcall      TDDVideoPortInfoPropertyEditor::GetValue
                                                                        ()
{
// retrieve a pointer to the property that the object inspector is using.
TDDVideoPortInfo* videoportinfo = (TDDVideoPortInfo*) GetOrdValue();

// return a string for the object inspector to display
//return To_TDDVideoPortInfoString( tvideoportinfo->Caps );
return "";
}

//---------------------------------------------------------------------------
// Method:          SetValue()
// Description:     This method sets the TDDVideoPortInfo's internal values
//                  by parsing the string as required.
//---------------------------------------------------------------------------
void                __fastcall      TDDVideoPortInfoPropertyEditor::SetValue(
                                                        AnsiString pValue )
{
// retrieve a pointer to the property that the object inspector is using.
TDDVideoPortInfo* videoportinfo = (TDDVideoPortInfo*) GetOrdValue();

// set the relevant parameters based on what the object inspector supplied.
//videoportinfo->Caps = From_TDDVideoPortInfoString( pValue );
}

//---------------------------------------------------------------------------
// Method:          GetAttributes()
// Description:     This method returns the attributes that tell the
//                  object inspector what functions to perform when
//                  editing the TDDVideoPortInfo property
//---------------------------------------------------------------------------
TPropertyAttributes __fastcall      TDDVideoPortInfoPropertyEditor::
                                                            GetAttributes()
{
// we want to open a dialog & the property should stay intact if unchanged
return TPropertyAttributes() << paDialog << paRevertable;
}

//---------------------------------------------------------------------------
// Method:          Edit()
// Description:     This method opens a custom TDDVideoPortInfo
//                  dialog box editor which is used to modify the various
//                  properties of the TDDVideoPortInfo class.
//---------------------------------------------------------------------------
void                __fastcall      TDDVideoPortInfoPropertyEditor::Edit()
{
// try creating the editor
TDDVideoPortInfoEditor* editor = new TDDVideoPortInfoEditor(Application);
if (editor==NULL) return;

// get a pointer to the property the object inspector is talking about
TDDVideoPortInfo* videoportinfo = (TDDVideoPortInfo*) GetOrdValue();

// setup the default values used by the editor
// editor->SCaps->Caps = caps->Caps;

// if the dialog was clicked OK.... update the appropriate values, then tell
// the designer that the values have changed
if (editor->ShowModal() == ID_OK)
    {
    // caps->Caps = editor->SCaps->Caps;
    Designer->Modified();
    }
delete editor;
}
//---------------------------------------------------------------------------

