//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

// ==========================================================================
// File:            TDDBltFX.CPP
// Description:
//
// (c) 1998 A.S.C. Alternate Software Concepts, Sydney, Australia.
// All Rights Reserved. Refer to the file TDirectX_Licence.Txt for detailed
// licence & copyright information
// ==========================================================================

// --------------------------------------------------------------------------
// include the TDDBltFX H file
// --------------------------------------------------------------------------
#include "TDDBltFX.h"

// --------------------------------------------------------------------------
// include the TDirectDrawSurface H file
// --------------------------------------------------------------------------
#include "TDirectDrawSurface.h"

// ==========================================================================
// Class:           TDDBltFX
// Description:     This object is a BCB-style wrapper for the DirectX
//                  DDBLTFX structure
// Notes:           By setting the various properties of a TDDBltFX object
//                  you can specify the type of blit operations to be
//                  performed.
// ==========================================================================

// --------------------------------------------------------------------------
// Constructor
// --------------------------------------------------------------------------
                    __fastcall  TDDBltFX::TDDBltFX() : TPersistent()
{
fBltFX.dwSize = sizeof(DDBLTFX);
}

// --------------------------------------------------------------------------
// Destructor
//---------------------------------------------------------------------------
                    __fastcall  TDDBltFX::~TDDBltFX()
{
}

// --------------------------------------------------------------------------
// Method:          Ptr
// Description:     This method returns a pointer to the internal
//                  DDBLTFX structure.
// --------------------------------------------------------------------------
DDBLTFX*            __fastcall  TDDBltFX::Ptr()
{
return &fBltFX;
}

// --------------------------------------------------------------------------
// Method:          FGetAlphaDest                                               //added Get
// Description:     Returns a pointer to a surface used as the alpha channel
//                  destination
//---------------------------------------------------------------------------
TDirectDrawSurface* __fastcall  TDDBltFX::FGetAlphaDest()
{
return NULL;
}

// --------------------------------------------------------------------------
// Method:          FSetAlphaDest
// Description:     Sets a pointer to a surface used as the alpha channel
//                  destination
//---------------------------------------------------------------------------
void                __fastcall  TDDBltFX::FSetAlphaDest( TDirectDrawSurface*
                                                                alphadest )
{
if (alphadest!=NULL) fBltFX.lpDDSAlphaDest = (LPDIRECTDRAWSURFACE)
                                                            alphadest->Ptr;
}

// --------------------------------------------------------------------------
// Method:          FGetAlphaDestConst
// Description:     Returns the constant used as the alpha channel
//                  destination
//---------------------------------------------------------------------------
dword               __fastcall  TDDBltFX::FGetAlphaDestConst()
{
return fBltFX.dwAlphaDestConst;
}

// --------------------------------------------------------------------------
// Method:          FSetAlphaDestConst
// Description:     Sets the constant used as the alpha channel destination
//---------------------------------------------------------------------------
void                __fastcall  TDDBltFX::FSetAlphaDestConst( dword
                                                            alphadestconst )
{
fBltFX.dwAlphaDestConst = alphadestconst;
}

// --------------------------------------------------------------------------
// Method:          FGetAlphaDestConstBitDepth
// Description:     Returns the bit depth of the destination alpha constant
//---------------------------------------------------------------------------
dword               __fastcall  TDDBltFX::FGetAlphaDestConstBitDepth()
{
return fBltFX.dwAlphaDestConstBitDepth;
}

// --------------------------------------------------------------------------
// Method:          FSetAlphaDestConstBitDepth
// Description:     Sets the bit depth of the destination alpha constant
//---------------------------------------------------------------------------
void                __fastcall  TDDBltFX::FSetAlphaDestConstBitDepth( dword
                                                    alphadestconstbitdepth )
{
fBltFX.dwAlphaDestConstBitDepth = alphadestconstbitdepth;
}

// --------------------------------------------------------------------------
// Method:          FGetAlphaEdgeBlend
// Description:     Returns the alpha constant used for edge blending
//---------------------------------------------------------------------------
dword               __fastcall  TDDBltFX::FGetAlphaEdgeBlend()
{
return fBltFX.dwAlphaEdgeBlend;
}

// --------------------------------------------------------------------------
// Method:          FSetAlphaEdgeBlend
// Description:     Sets the alpha constant used for edge blending
//---------------------------------------------------------------------------
void                __fastcall  TDDBltFX::FSetAlphaEdgeBlend( dword
                                                            alphaedgeblend )
{
fBltFX.dwAlphaEdgeBlend = alphaedgeblend;
}

// --------------------------------------------------------------------------
// Method:          FGetAlphaEdgeBlendBitDepth
// Description:     Returns the bit depth of the constant for an alpha edge
//                  blend
//---------------------------------------------------------------------------
dword               __fastcall  TDDBltFX::FGetAlphaEdgeBlendBitDepth()
{
return fBltFX.dwAlphaEdgeBlendBitDepth;
}

// --------------------------------------------------------------------------
// Method:          FSetAlphaEdgeBlendBitDepth
// Description:     Sets the bit depth of the constant for an alpha edge
//                  blend
//---------------------------------------------------------------------------
void                __fastcall  TDDBltFX::FSetAlphaEdgeBlendBitDepth( dword
                                                    alphaedgeblendbitdepth )
{
fBltFX.dwAlphaEdgeBlendBitDepth = alphaedgeblendbitdepth;
}

// --------------------------------------------------------------------------
// Method:          FGetAlphaSrc                                                //added Get
// Description:     Returns a pointer to a surface used as the alpha channel
//                  source
//---------------------------------------------------------------------------
TDirectDrawSurface* __fastcall  TDDBltFX::FGetAlphaSrc()
{
return NULL;
}

// --------------------------------------------------------------------------
// Method:          FSetAlphaSrc
// Description:     Sets a pointer to a surface used as the alpha channel
//                  source
//---------------------------------------------------------------------------
void                __fastcall  TDDBltFX::FSetAlphaSrc( TDirectDrawSurface*
                                                                alphasrc )
{
if (alphasrc!=NULL) fBltFX.lpDDSAlphaSrc = (LPDIRECTDRAWSURFACE)
                                                            alphasrc->Ptr;
}

// --------------------------------------------------------------------------
// Method:          FGetAlphaSrcConst
// Description:     Returns the constant used as the alpha channel source
//---------------------------------------------------------------------------
dword               __fastcall  TDDBltFX::FGetAlphaSrcConst()
{
return fBltFX.dwAlphaSrcConst;
}

// --------------------------------------------------------------------------
// Method:          FSetAlphaSrcConst
// Description:     Sets the constant used as the alpha channel source
//---------------------------------------------------------------------------
void                __fastcall  TDDBltFX::FSetAlphaSrcConst( dword
                                                            alphasrcconst )
{
fBltFX.dwAlphaSrcConst = alphasrcconst;
}

// --------------------------------------------------------------------------
// Method:          FGetAlphaSrcConstBitDepth
// Description:     Returns the bit depth of the source alpha constant
//---------------------------------------------------------------------------
dword               __fastcall  TDDBltFX::FGetAlphaSrcConstBitDepth()
{
return fBltFX.dwAlphaSrcConstBitDepth;
}

// --------------------------------------------------------------------------
// Method:          FSetAlphaSrcConstBitDepth
// Description:     Sets the bit depth of the source alpha constant
//---------------------------------------------------------------------------
void                __fastcall  TDDBltFX::FSetAlphaSrcConstBitDepth( dword
                                                    alphasrcconstbitdepth )
{
fBltFX.dwAlphaSrcConstBitDepth = alphasrcconstbitdepth;
}

// --------------------------------------------------------------------------
// Method:          FGetDDFX
// Description:     Returns the type of FX operations
//---------------------------------------------------------------------------
dword               __fastcall  TDDBltFX::FGetDDFX()
{
return fBltFX.dwDDFX;
}

// --------------------------------------------------------------------------
// Method:          FSetDDFX
// Description:     Sets the type of FX operations
//---------------------------------------------------------------------------
void                __fastcall  TDDBltFX::FSetDDFX( dword ddfx )
{
fBltFX.dwDDFX = ddfx;
}

// --------------------------------------------------------------------------
// Method:          FGetDDRop
// Description:     Returns the DirectDraw raster operations
//---------------------------------------------------------------------------
dword               __fastcall  TDDBltFX::FGetDDRop()
{
return fBltFX.dwDDROP;
}

// --------------------------------------------------------------------------
// Method:          FSetDDRop
// Description:     Sets the DirectDraw raster operations
//---------------------------------------------------------------------------
void                __fastcall  TDDBltFX::FSetDDRop( dword ddrop )
{
fBltFX.dwDDROP = ddrop;
}

// --------------------------------------------------------------------------
// Method:          FGetDestColorKey                                            //added Get
// Description:     Returns the destination color key override
//---------------------------------------------------------------------------
TDDColorKey*        __fastcall  TDDBltFX::FGetDestColorKey()
{
return NULL;
}

// --------------------------------------------------------------------------
// Method:          FSetDestColorKey
// Description:     Sets the destination color key override
//---------------------------------------------------------------------------
void                __fastcall  TDDBltFX::FSetDestColorKey( TDDColorKey*
                                                            destcolorkey )
{
if (destcolorkey!=NULL) CopyMemory( &fBltFX.ddckDestColorkey,
                                destcolorkey->Ptr(), destcolorkey->Size() );
}

// --------------------------------------------------------------------------
// Method:          FGetFillColor
// Description:     Returns the color used to fill a surface when
//                  ddblt_ColorFill is specified
// Notes:           This value must be a pixel appropriate to the pixel
//                  format of the destination surface. For a palettized
//                  surface it would be a palette index, and for a 16-bit RGB
//                  surface it would be a 16-bit pixel value
//---------------------------------------------------------------------------
dword               __fastcall  TDDBltFX::FGetFillColor()
{
return fBltFX.dwFillColor;
}

// --------------------------------------------------------------------------
// Method:          FSetFillColor
// Description:     Sets the color used to fill a surface when
//                  ddblt_ColorFill is specified
// Notes:           This value must be a pixel appropriate to the pixel
//                  format of the destination surface. For a palettized
//                  surface it would be a palette index, and for a 16-bit RGB
//                  surface it would be a 16-bit pixel value
//---------------------------------------------------------------------------
void                __fastcall  TDDBltFX::FSetFillColor( dword fillcolor )
{
fBltFX.dwFillColor = fillcolor;
}

// --------------------------------------------------------------------------
// Method:          FGetFillDepth
// Description:     Returns the depth value of the z-buffer
//---------------------------------------------------------------------------
dword               __fastcall  TDDBltFX::FGetFillDepth()
{
return fBltFX.dwFillDepth;
}

// --------------------------------------------------------------------------
// Method:          FSetFillDepth
// Description:     Sets the depth value of the z-buffer
//---------------------------------------------------------------------------
void                __fastcall  TDDBltFX::FSetFillDepth( dword filldepth )
{
fBltFX.dwFillDepth = filldepth;
}

// --------------------------------------------------------------------------
// Method:          FGetFillPixel
// Description:     Returns the pixel value for RGBA or RGBZ fills
// Notes:           Applications that use RGBZ fills should use this property
//                  rather than FillColor or FillDepth
//---------------------------------------------------------------------------
dword               __fastcall  TDDBltFX::FGetFillPixel()
{
return fBltFX.dwFillPixel;
}

// --------------------------------------------------------------------------
// Method:          FSetFillPixel
// Description:     Sets the pixel value for RGBA or RGBZ fills
// Notes:           Applications that use RGBZ fills should use this property
//                  rather than FillColor or FillDepth
//---------------------------------------------------------------------------
void                __fastcall  TDDBltFX::FSetFillPixel( dword fillpixel )
{
fBltFX.dwFillPixel = fillpixel;
}

// --------------------------------------------------------------------------
// Method:          FGetPattern                                                 //added Get
// Description:     Returns the surface to use as a pattern
// Note:            The pattern can be used in certain blit operations that
//                  combine a source and a destination
//---------------------------------------------------------------------------
TDirectDrawSurface* __fastcall  TDDBltFX::FGetPattern()
{
return NULL;
}
// --------------------------------------------------------------------------
// Method:          FSetPattern
// Description:     Sets the surface to use as a pattern
// Note:            The pattern can be used in certain blit operations that
//                  combine a source and a destination
//---------------------------------------------------------------------------
void                __fastcall  TDDBltFX::FSetPattern( TDirectDrawSurface*
                                                                    pattern )
{
if (pattern!=NULL) fBltFX.lpDDSPattern = (LPDIRECTDRAWSURFACE) pattern->Ptr;
}

// --------------------------------------------------------------------------
// Method:          FGetRop
// Description:     Returns the Win32 raster operations
// Notes:           You can retrieve a list of supported raster operations by
//                  calling the TDirectDraw::GetCaps method
//---------------------------------------------------------------------------
dword               __fastcall  TDDBltFX::FGetRop()
{
return fBltFX.dwROP;
}

//---------------------------------------------------------------------------
// Method:          FSetRop
// Description:     Sets the Win32 raster operations
// Notes:           You can retrieve a list of supported raster operations by
//                  calling the TDirectDraw::GetCaps method
//---------------------------------------------------------------------------
void                __fastcall  TDDBltFX::FSetRop( dword rop )
{
fBltFX.dwROP = rop;
}

// --------------------------------------------------------------------------
// Method:          FGetRotationAngle
// Description:     Returns the rotation angle for the blit
//---------------------------------------------------------------------------
dword               __fastcall  TDDBltFX::FGetRotationAngle()
{
return fBltFX.dwRotationAngle;
}

// --------------------------------------------------------------------------
// Method:          FSetRotationAngle
// Description:     Sets the rotation angle for the blit
//---------------------------------------------------------------------------
void                __fastcall  TDDBltFX::FSetRotationAngle( dword
                                                            rotationangle )
{
fBltFX.dwRotationAngle = rotationangle;
}

// --------------------------------------------------------------------------
// Method:          FGetSize
// Description:     This returns the size of the internal DDBLTFX
//                  structure.
// --------------------------------------------------------------------------
dword               __fastcall  TDDBltFX::FGetSize()
{
return sizeof(DDBLTFX);
}

// --------------------------------------------------------------------------
// Method:          FSetSize                                                    //added set
// Description:     This sets the size of the internal DDBLTFX structure.
// --------------------------------------------------------------------------
void                __fastcall  TDDBltFX::FSetSize( dword pSize )
{
return;
}

// --------------------------------------------------------------------------
// Method:          FGetSrcColorKey
// Description:     Returns the source color key override
//---------------------------------------------------------------------------
TDDColorKey*        __fastcall  TDDBltFX::FGetSrcColorKey()
{
return NULL;
}
// --------------------------------------------------------------------------
// Method:          FSetSrcColorKey
// Description:     Sets the source color key override
//---------------------------------------------------------------------------
void                __fastcall  TDDBltFX::FSetSrcColorKey( TDDColorKey*
                                                                srccolorkey )
{
if (srccolorkey!=NULL) CopyMemory( &fBltFX.ddckSrcColorkey,
                                srccolorkey->Ptr(), srccolorkey->Size() );
}

// --------------------------------------------------------------------------
// Method:          FGetZBufferBaseDest
// Description:     Returns the destination base value of a z-buffer
//---------------------------------------------------------------------------
dword               __fastcall  TDDBltFX::FGetZBufferBaseDest()
{
return fBltFX.dwZBufferBaseDest;
}

// --------------------------------------------------------------------------
// Method:          FSetZBufferBaseDest
// Description:     Sets the destination base value of a z-buffer
//---------------------------------------------------------------------------
void                __fastcall  TDDBltFX::FSetZBufferBaseDest( dword
                                                            zbufferbasedest )
{
fBltFX.dwZBufferBaseDest = zbufferbasedest;
}

// --------------------------------------------------------------------------
// Method:          FGetZBufferDest                                             //added get
// Description:     Returns a pointer to the surface used as the z-buffer
//                  destination
//---------------------------------------------------------------------------
TDirectDrawSurface* __fastcall  TDDBltFX::FGetZBufferDest()
{
return NULL;
}

// --------------------------------------------------------------------------
// Method:          FSetZBufferDest
// Description:     Sets a pointer to the surface used as the z-buffer
//                  destination
//---------------------------------------------------------------------------
void                __fastcall  TDDBltFX::FSetZBufferDest(
                                            TDirectDrawSurface* zbufferdest )
{
if (zbufferdest!=NULL) fBltFX.lpDDSZBufferDest = (LPDIRECTDRAWSURFACE)
                                                            zbufferdest->Ptr;
}

// --------------------------------------------------------------------------
// Method:          FGetZBufferHigh
// Description:     Returns the high Limit of a z-buffer
//---------------------------------------------------------------------------
dword               __fastcall  TDDBltFX::FGetZBufferHigh()
{
return fBltFX.dwZBufferHigh;
}

// --------------------------------------------------------------------------
// Method:          FSetZBufferHigh
// Description:     Sets the high Limit of a z-buffer
//---------------------------------------------------------------------------
void                __fastcall  TDDBltFX::FSetZBufferHigh( dword
                                                                zbufferhigh )
{
fBltFX.dwZBufferHigh = zbufferhigh;
}

// --------------------------------------------------------------------------
// Method:          FGetZBufferLow
// Description:     Returns the low limit of a z-buffer
//---------------------------------------------------------------------------
dword               __fastcall  TDDBltFX::FGetZBufferLow()
{
return fBltFX.dwZBufferLow;
}

// --------------------------------------------------------------------------
// Method:          FSetZBufferLow
// Description:     Sets the low limit of a z-buffer
//---------------------------------------------------------------------------
void                __fastcall  TDDBltFX::FSetZBufferLow( dword zbufferlow )
{
fBltFX.dwZBufferLow = zbufferlow;
}

// --------------------------------------------------------------------------
// Method:          FGetZBufferOpCode
// Description:     Returns the Z-Buffer Compares
//---------------------------------------------------------------------------
dword               __fastcall  TDDBltFX::FGetZBufferOpCode()
{
return fBltFX.dwZBufferOpCode;
}

// --------------------------------------------------------------------------
// Method:          FSetZBufferOpCode
// Description:     Sets the Z-Buffer Compares
//---------------------------------------------------------------------------
void                __fastcall  TDDBltFX::FSetZBufferOpCode( dword
                                                            zbufferopcode )
{
fBltFX.dwZBufferOpCode = zbufferopcode;
}

// --------------------------------------------------------------------------
// Method:          FGetZBufferSrc                                              //added Get
// Description:     Returns a pointer to the surface used as the z-buffer
//                  source
//---------------------------------------------------------------------------
TDirectDrawSurface* __fastcall  TDDBltFX::FGetZBufferSrc()
{
return NULL;
}

// --------------------------------------------------------------------------
// Method:          FSetZBufferSrc
// Description:     Sets a pointer to the surface used as the z-buffer source
//---------------------------------------------------------------------------
void                __fastcall  TDDBltFX::FSetZBufferSrc( TDirectDrawSurface*
                                                                 zbuffersrc )
{
if (zbuffersrc!=NULL) fBltFX.lpDDSZBufferSrc = (LPDIRECTDRAWSURFACE)
                                                            zbuffersrc->Ptr;
}

// --------------------------------------------------------------------------
// Method:          FGetZDestConst
// Description:     Returns the constant used as the z-buffer destination
//---------------------------------------------------------------------------
dword               __fastcall  TDDBltFX::FGetZDestConst()
{
return fBltFX.dwZDestConst;
}

// --------------------------------------------------------------------------
// Method:          FSetZDestConst
// Description:     Sets the constant used as the z-buffer destination
//---------------------------------------------------------------------------
void                __fastcall  TDDBltFX::FSetZDestConst( dword zdestconst )
{
fBltFX.dwZDestConst = zdestconst;
}

// --------------------------------------------------------------------------
// Method:          FGetZDestConstBitDepth
// Description:     Returns the bit depth of the destination z-constant
//---------------------------------------------------------------------------
dword               __fastcall  TDDBltFX::FGetZDestConstBitDepth()
{
return fBltFX.dwZDestConstBitDepth;
}

// --------------------------------------------------------------------------
// Method:          FSetZDestConstBitDepth
// Description:     Sets the bit depth of the destination z-constant
//---------------------------------------------------------------------------
void                __fastcall  TDDBltFX::FSetZDestConstBitDepth( dword
                                                        zdestconstbitdepth )
{
fBltFX.dwZDestConstBitDepth = zdestconstbitdepth;
}

// --------------------------------------------------------------------------
// Method:          FGetZSrcConst
// Description:     Returns the constant used as the zbuffer source
//---------------------------------------------------------------------------
dword               __fastcall  TDDBltFX::FGetZSrcConst()
{
return fBltFX.dwZSrcConst;
}

// --------------------------------------------------------------------------
// Method:          FSetZSrcConst
// Description:     Sets the constant used as the zbuffer source
//---------------------------------------------------------------------------
void                __fastcall  TDDBltFX::FSetZSrcConst( dword zsrcconst )
{
fBltFX.dwZSrcConst = zsrcconst;
}

// --------------------------------------------------------------------------
// Method:          FGetZSrcConstBitDepth
// Description:     Returns the bit depth of the source z-constant
//---------------------------------------------------------------------------
dword               __fastcall  TDDBltFX::FGetZSrcConstBitDepth()
{
return fBltFX.dwZSrcConstBitDepth;
}

// --------------------------------------------------------------------------
// Method:          FSetZSrcConstBitDepth
// Description:     Sets the bit depth of the source z-constant
//---------------------------------------------------------------------------
void                __fastcall  TDDBltFX::FSetZSrcConstBitDepth( dword
                                                        zsrcconstbitdepth )
{
fBltFX.dwZSrcConstBitDepth = zsrcconstbitdepth;
}

//---------------------------------------------------------------------------

