//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

// ==========================================================================
// File:            TDDColorKey.CPP
// Description:
//
// (c) 1998 A.S.C. Alternate Software Concepts, Sydney, Australia.
// All Rights Reserved. Refer to the file TDirectX_Licence.Txt for detailed
// licence & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// include the TDDColorKey H file.
// --------------------------------------------------------------------------
#include "TDDColorKey.h"

// ==========================================================================
// Class:           TDDColorKey
// Description:     This object describes a source color key, destination
//                  color key, or color space.
// Notes:           A color key is specified if the low and high range values
//                  are the same.
//                  This object is used with the
//                  TDirectDrawSurface::GetColorKey and
//                  TDirectDrawSurface::SetColorKey methods
// ==========================================================================

// --------------------------------------------------------------------------
// Constructor
// --------------------------------------------------------------------------
                    __fastcall  TDDColorKey::TDDColorKey() : TPersistent()
{
fColorKey.dwColorSpaceLowValue = clBlack;
fColorKey.dwColorSpaceHighValue = clBlack;
}

// --------------------------------------------------------------------------
// Destructor
// --------------------------------------------------------------------------
                    __fastcall  TDDColorKey::~TDDColorKey()
{
}

// --------------------------------------------------------------------------
// Method:          Ptr
// Description:     This property returns a pointer to the internal
//                  DDCOLORKEY structure.
// --------------------------------------------------------------------------
DDCOLORKEY*         __fastcall  TDDColorKey::Ptr()
{
return &fColorKey;
}

// --------------------------------------------------------------------------
// Property:        FGetHighValue
// Description:     Returns the high value, inclusive, of the color range
//                  that is to be used as the color key
//---------------------------------------------------------------------------
dword           __fastcall      TDDColorKey::FGetHighValue()
{
return fColorKey.dwColorSpaceHighValue;
}

// --------------------------------------------------------------------------
// Property:        FGetHighValue
// Description:     Sets the high value, inclusive, of the color range
//                  that is to be used as the color key
//---------------------------------------------------------------------------
void            __fastcall      TDDColorKey::FSetHighValue( dword highvalue )
{
fColorKey.dwColorSpaceHighValue = highvalue;
}

// --------------------------------------------------------------------------
// Property:        FGetLowValue
// Description:     Returns the low value, inclusive, of the color range that
//                  is to be used as the color key
//---------------------------------------------------------------------------
dword               __fastcall  TDDColorKey::FGetLowValue()
{
return fColorKey.dwColorSpaceLowValue;
}

// --------------------------------------------------------------------------
// Property:        FSetLowValue
// Description:     Sets the low value, inclusive, of the color range
//                  that is to be used as the color key
//---------------------------------------------------------------------------
void            __fastcall      TDDColorKey::FSetLowValue( dword lowvalue )
{
fColorKey.dwColorSpaceLowValue = lowvalue;
}

// --------------------------------------------------------------------------
// Method:          FGetSize
// Description:     This returns the size of the internal DDCOLORKEY
//                  structure
// --------------------------------------------------------------------------
dword               __fastcall  TDDColorKey::FGetSize()
{
return sizeof(DDCOLORKEY);
}

// --------------------------------------------------------------------------
// Method:          FSetSize                                                    //added set
// Description:     This sets the size of the internal DDCOLORKEY structure
// --------------------------------------------------------------------------
void               __fastcall  TDDColorKey::FSetSize( dword pSize )
{
return;
}

//---------------------------------------------------------------------------

