//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

// ==========================================================================
// File:            TDDOverlayFX.CPP
// Description:
//
// (c) 1998 A.S.C. Alternate Software Concepts, Sydney, Australia.
// All Rights Reserved. Refer to the file TDirectX_Licence.Txt for detailed
// licence & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// include the TDDOverlayFX H file.
// --------------------------------------------------------------------------
#include "TDDOverlayFX.h"

// ==========================================================================
// Class:           TDDOverlayFX
// Description:     This object is a BCB-style wrapper for the DirectX
//                  DDOVERLAYFX structure
// ==========================================================================

// --------------------------------------------------------------------------
// Constructor
// --------------------------------------------------------------------------
                    __fastcall  TDDOverlayFX::TDDOverlayFX() : TPersistent()
{
fOverlayFX.dwSize = sizeof(DDOVERLAYFX);
}

// --------------------------------------------------------------------------
// Destructor
//---------------------------------------------------------------------------
                    __fastcall  TDDOverlayFX::~TDDOverlayFX()
{
}

// --------------------------------------------------------------------------
// Method:          Ptr
// Description:     This method returns a pointer to the internal
//                  DDOVERLAYFX structure.
// --------------------------------------------------------------------------
DDOVERLAYFX*        __fastcall  TDDOverlayFX::Ptr()
{
return &fOverlayFX;
}

// --------------------------------------------------------------------------
// Method:          FGetAlphaDest                                               //added get
// Description:     Returns the address of a surface used as the alpha
//                  channel for a destination
//---------------------------------------------------------------------------
TDirectDrawSurface* __fastcall  TDDOverlayFX::FGetAlphaDest()
{
return NULL;
}

// --------------------------------------------------------------------------
// Method:          FSetAlphaDest
// Description:     Sets the address of a surface to use as the alpha
//                  channel for a destination
//---------------------------------------------------------------------------
void                __fastcall  TDDOverlayFX::FSetAlphaDest(
                                            TDirectDrawSurface* alphadest )
{
if (alphadest!=NULL) fOverlayFX.lpDDSAlphaDest = (LPDIRECTDRAWSURFACE)
                                                            alphadest->Ptr;
}

// --------------------------------------------------------------------------
// Method:          FGetAlphaDestConst
// Description:     Returns the constant used as the alpha channel for a
//                  destination
//---------------------------------------------------------------------------
dword               __fastcall  TDDOverlayFX::FGetAlphaDestConst()
{
return fOverlayFX.dwAlphaDestConst;
}

// --------------------------------------------------------------------------
// Method:          FSetAlphaDestConst
// Description:     Sets the constant to use as the alpha channel for a
//                  destination
//---------------------------------------------------------------------------
void                __fastcall  TDDOverlayFX::FSetAlphaDestConst( dword
                                                            alphadestconst )
{
fOverlayFX.dwAlphaDestConst = alphadestconst;
}

// --------------------------------------------------------------------------
// Method:          FGetAlphaDestConstBitDepth
// Description:     Returns the bit depth used to specify the alpha constant
//                  for a destination
//---------------------------------------------------------------------------
dword       __fastcall  TDDOverlayFX::FGetAlphaDestConstBitDepth()
{
return fOverlayFX.dwAlphaDestConstBitDepth;
}

// --------------------------------------------------------------------------
// Method:          FSetAlphaDestConstBitDepth
// Description:     Sets the bit depth used to specify the alpha constant for
//                  a destination
//---------------------------------------------------------------------------
void                __fastcall  TDDOverlayFX::FSetAlphaDestConstBitDepth(
                                            dword alphadestconstbitdepth )
{
fOverlayFX.dwAlphaDestConstBitDepth = alphadestconstbitdepth;
}

// --------------------------------------------------------------------------
// Method:          FGetAlphaEdgeBlend
// Description:     Returns the constant used as the alpha for an edge blend
//---------------------------------------------------------------------------
dword               __fastcall  TDDOverlayFX::FGetAlphaEdgeBlend()
{
return fOverlayFX.dwAlphaEdgeBlend;
}

// --------------------------------------------------------------------------
// Method:          FSetAlphaEdgeBlend
// Description:     Sets the constant to use as the alpha for an edge blend
//---------------------------------------------------------------------------
void                __fastcall  TDDOverlayFX::FSetAlphaEdgeBlend( dword
                                                            alphaedgeblend )
{
fOverlayFX.dwAlphaEdgeBlend = alphaedgeblend;
}

// --------------------------------------------------------------------------
// Method:          FGetAlphaEdgeBlendBitDepth
// Description:     Returns the bit depth used to specify the constant for an
//                  alpha edge blend
//---------------------------------------------------------------------------
dword               __fastcall  TDDOverlayFX::FGetAlphaEdgeBlendBitDepth()
{
return fOverlayFX.dwAlphaEdgeBlendBitDepth;
}

// --------------------------------------------------------------------------
// Method:          FSetAlphaEdgeBlendBitDepth
// Description:     Sets the bit depth used to specify the constant for an
//                  alpha edge blend
//---------------------------------------------------------------------------
void                __fastcall  TDDOverlayFX::FSetAlphaEdgeBlendBitDepth(
                                            dword alphaedgeblendbitdepth )
{
fOverlayFX.dwAlphaEdgeBlendBitDepth = alphaedgeblendbitdepth;
}

// --------------------------------------------------------------------------
// Method:          FGetAlphaSrc                                                //added get
// Description:     Returns the address for a surface used as the alpha
//                  channel for a source
//---------------------------------------------------------------------------
TDirectDrawSurface* __fastcall  TDDOverlayFX::FGetAlphaSrc()
{
return NULL;
}

// --------------------------------------------------------------------------
// Method:          FSetAlphaSrc
// Description:     Sets the address for a surface to use as the alpha
//                  channel for a source
//---------------------------------------------------------------------------
void                __fastcall  TDDOverlayFX::FSetAlphaSrc(
                                            TDirectDrawSurface* alphasrc )
{
if (alphasrc!=NULL) fOverlayFX.lpDDSAlphaSrc = (LPDIRECTDRAWSURFACE)
                                                            alphasrc->Ptr;
}

// --------------------------------------------------------------------------
// Method:          FGetAlphaSrcConst
// Description:     Returns the constant used as the alpha channel for a
//                  source
//---------------------------------------------------------------------------
dword       __fastcall  TDDOverlayFX::FGetAlphaSrcConst()
{
return fOverlayFX.dwAlphaSrcConst;
}

// --------------------------------------------------------------------------
// Method:          FSetAlphaSrcConst
// Description:     Sets the constant to use as the alpha channel for a
//                  source
//---------------------------------------------------------------------------
void                __fastcall  TDDOverlayFX::FSetAlphaSrcConst( dword
                                                            alphasrcconst )
{
fOverlayFX.dwAlphaSrcConst = alphasrcconst;
}

// --------------------------------------------------------------------------
// Method:          FGetAlphaSrcConstBitDepth
// Description:     Returns the current bit depth used to specify the alpha
//                  constant for a source
//---------------------------------------------------------------------------
dword               __fastcall  TDDOverlayFX::FGetAlphaSrcConstBitDepth()
{
return fOverlayFX.dwAlphaSrcConstBitDepth;
}

// --------------------------------------------------------------------------
// Method:          FSetAlphaSrcConstBitDepth
// Description:     Sets the bit depth used to specify the alpha constant for
//                  a source
//---------------------------------------------------------------------------
void                __fastcall  TDDOverlayFX::FSetAlphaSrcConstBitDepth(
                                                dword alphasrcconstbitdepth )
{
fOverlayFX.dwAlphaSrcConstBitDepth = alphasrcconstbitdepth;
}

// --------------------------------------------------------------------------
// Method:          FGetDDFX
// Description:     Returns the current overlay FX flags
//---------------------------------------------------------------------------
dword               __fastcall  TDDOverlayFX::FGetDDFX()
{
return fOverlayFX.dwDDFX;
}

// --------------------------------------------------------------------------
// Method:          FSetDDFX
// Description:     Sets the overlay FX flags
//---------------------------------------------------------------------------
void                __fastcall  TDDOverlayFX::FSetDDFX( dword ddfx )
{
fOverlayFX.dwDDFX = ddfx;
}
// --------------------------------------------------------------------------
// Method:          FGetDestColorKey                                            //added get
// Description:     Returns the destination color key override
//---------------------------------------------------------------------------
TDDColorKey*        __fastcall  TDDOverlayFX::FGetDestColorKey()
{
return NULL;
}

// --------------------------------------------------------------------------
// Method:          FSetDestColorKey
// Description:     Sets the destination color key override
//---------------------------------------------------------------------------
void                __fastcall  TDDOverlayFX::FSetDestColorKey( TDDColorKey*
                                                            destcolorkey )
{
if (destcolorkey!=NULL) CopyMemory(&fOverlayFX.dckDestColorkey,
                                destcolorkey->Ptr(),destcolorkey->Size());
}

// --------------------------------------------------------------------------
// Method:          FGetSize
// Description:     This returns the size of the internal DDOVERLAYFX
//                  structure
// --------------------------------------------------------------------------
dword               __fastcall  TDDOverlayFX::FGetSize()
{
return sizeof(DDOVERLAYFX);
}

// --------------------------------------------------------------------------
// Method:          FSetSize                                                    //added set
// Description:     This sets the size of the internal DDOVERLAYFX structure
// --------------------------------------------------------------------------
void                __fastcall  TDDOverlayFX::FSetSize( dword pSize )
{
return;
}

// --------------------------------------------------------------------------
// Method:          FGetSrcColorKey                                             //added get
// Description:     Returns the source color key override
//---------------------------------------------------------------------------
TDDColorKey*        __fastcall  TDDOverlayFX::FGetSrcColorKey()
{
return NULL;
}

// --------------------------------------------------------------------------
// Method:          FSetSrcColorKey
// Description:     Sets the source color key override
//---------------------------------------------------------------------------
void                __fastcall  TDDOverlayFX::FSetSrcColorKey( TDDColorKey*
                                                                srccolorkey )
{
if (srccolorkey!=NULL) CopyMemory(&fOverlayFX.dckSrcColorkey,
                                    srccolorkey->Ptr(),srccolorkey->Size());
}

//---------------------------------------------------------------------------

