//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

// ==========================================================================
// File:            TDDPixelFormat.CPP
// Description:
//
// (c) 1998 A.S.C. Alternate Software Concepts, Sydney, Australia.
// All Rights Reserved. Refer to the file TDirectX_Licence.Txt for detailed
// licence & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// include the TDDBltBatch H file.
// --------------------------------------------------------------------------
#include "TDDPixelFormat.h"

// ==========================================================================
// Class:           TDDPixelFormat
// Description:     This object describes the pixel format of a
//                  TDirectDrawSurface object for the
//                  TDirectDrawSurface::GetPixelFormat method
// ==========================================================================

// --------------------------------------------------------------------------
// Constructor
// --------------------------------------------------------------------------
                    __fastcall  TDDPixelFormat::TDDPixelFormat() :
                                                                TPersistent()
{
fPixelFormat.dwSize = sizeof(DDPIXELFORMAT);
}

// --------------------------------------------------------------------------
// Destructor
//---------------------------------------------------------------------------
__fastcall      TDDPixelFormat::~TDDPixelFormat()
{
}

// --------------------------------------------------------------------------
// Method:          Ptr
// Description:     This method returns a pointer to the internal
//                  DDPIXELFORMAT structure.
//---------------------------------------------------------------------------
DDPIXELFORMAT*      __fastcall  TDDPixelFormat::Ptr()
{
return &fPixelFormat;
}

// --------------------------------------------------------------------------
// Method:          FGetAlphaBitDepth
// Description:     Returns alpha channel bit depth
// Type:            1, 2, 4 or 8
//---------------------------------------------------------------------------
dword               __fastcall  TDDPixelFormat::FGetAlphaBitDepth()
{
return fPixelFormat.dwAlphaBitDepth;
}

// --------------------------------------------------------------------------
// Method:          FSetAlphaBitDepth
// Description:     Sets alpha channel bit depth
// Type:            1, 2, 4 or 8
//---------------------------------------------------------------------------
void                __fastcall  TDDPixelFormat::FSetAlphaBitDepth( dword
                                                            alphabitdepth )
{
fPixelFormat.dwAlphaBitDepth = alphabitdepth;
}

// --------------------------------------------------------------------------
// Method:          FGetBBitMask
// Description:     Returns the mask for blue bits
//---------------------------------------------------------------------------
dword               __fastcall  TDDPixelFormat::FGetBBitMask()
{
return fPixelFormat.dwBBitMask;
}

// --------------------------------------------------------------------------
// Method:          FSetBBitMask
// Description:     Sets the mask for blue bits
//---------------------------------------------------------------------------
void                __fastcall  TDDPixelFormat::FSetBBitMask( dword
                                                                bbitmask )
{
fPixelFormat.dwBBitMask = bbitmask;
}

// --------------------------------------------------------------------------
// Method:          FGetFlags
// Description:     Returns current optional control flag settings
//---------------------------------------------------------------------------
dword               __fastcall  TDDPixelFormat::FGetFlags()
{
return fPixelFormat.dwFlags;
}

// --------------------------------------------------------------------------
// Method:          FSetFlags
// Description:     Sets optional control flags
//---------------------------------------------------------------------------
void                __fastcall  TDDPixelFormat::FSetFlags( dword flags )
{
fPixelFormat.dwFlags = flags;
}

// --------------------------------------------------------------------------
// Method:          FGetFourCC
// Description:     Returns the current FourCC codes
//---------------------------------------------------------------------------
dword               __fastcall  TDDPixelFormat::FGetFourCC()
{
return fPixelFormat.dwFourCC;
}

// --------------------------------------------------------------------------
// Method:          FSetFourCC
// Description:     Sets FourCC codes
//---------------------------------------------------------------------------
void                __fastcall  TDDPixelFormat::FSetFourCC( dword fourcc )
{
fPixelFormat.dwFourCC = fourcc;
}

// --------------------------------------------------------------------------
// Method:          FGetGBitMask
// Description:     Returns the mask for green bits
//---------------------------------------------------------------------------
dword               __fastcall  TDDPixelFormat::FGetGBitMask()
{
return fPixelFormat.dwGBitMask;
}

// --------------------------------------------------------------------------
// Method:          FSetGBitMask
// Description:     Sets the mask for green bits
//---------------------------------------------------------------------------
void                __fastcall  TDDPixelFormat::FSetGBitMask( dword
                                                                gbitmask )
{
fPixelFormat.dwGBitMask = gbitmask;
}

// --------------------------------------------------------------------------
// Method:          FGetRBitMask
// Description:     Returns the mask for red bits
//---------------------------------------------------------------------------
dword               __fastcall  TDDPixelFormat::FGetRBitMask()
{
return fPixelFormat.dwRBitMask;
}

// --------------------------------------------------------------------------
// Method:          FSetRBitMask
// Description:     Sets the mask for red bits
//---------------------------------------------------------------------------
void                __fastcall  TDDPixelFormat::FSetRBitMask( dword
                                                                rbitmask )
{
fPixelFormat.dwRBitMask = rbitmask;
}

// --------------------------------------------------------------------------
// Method:          FGetRGBAlphaBitMask
// Description:     Returns the mask for alpha channel
//---------------------------------------------------------------------------
dword               __fastcall  TDDPixelFormat::FGetRGBAlphaBitMask()
{
return fPixelFormat.dwRGBAlphaBitMask;
}

// --------------------------------------------------------------------------
// Method:          FSetRGBAlphaBitMask
// Description:     Sets the mask for alpha channel
//---------------------------------------------------------------------------
void                __fastcall  TDDPixelFormat::FSetRGBAlphaBitMask( dword
                                                            rgbalphabitmask )
{
fPixelFormat.dwRGBAlphaBitMask = rgbalphabitmask;
}

// --------------------------------------------------------------------------
// Method:          FGetRGBBitCount
// Description:     Returns RGB bits per pixel
// Note:            4, 8, 16, 24 or 32
//---------------------------------------------------------------------------
dword               __fastcall  TDDPixelFormat::FGetRGBBitCount()
{
return fPixelFormat.dwRGBBitCount;
}

// --------------------------------------------------------------------------
// Method:          FSetRGBBitCount
// Description:     Sets RGB bits per pixel
// Note:            4, 8, 16, 24 or 32
//---------------------------------------------------------------------------
void                __fastcall  TDDPixelFormat::FSetRGBBitCount( dword
                                                                rgbbitcount )
{
fPixelFormat.dwRGBBitCount = rgbbitcount;
}

// --------------------------------------------------------------------------
// Method:          FGetRGBZBitMask
// Description:     Returns the mask for the Z channel
//---------------------------------------------------------------------------
dword       __fastcall  TDDPixelFormat::FGetRGBZBitMask()
{
return fPixelFormat.dwRGBZBitMask;
}

// --------------------------------------------------------------------------
// Method:          FSetRGBZBitMask
// Description:     Sets the mask for the Z channel
//---------------------------------------------------------------------------
void                __fastcall  TDDPixelFormat::FSetRGBZBitMask( dword
                                                                rgbzbitmask )
{
fPixelFormat.dwRGBZBitMask = rgbzbitmask;
}

// --------------------------------------------------------------------------
// Method:          FGetSize
// Description:     This returns the size of the internal DDPIXELFORMAT
//                  structure
// --------------------------------------------------------------------------
dword               __fastcall  TDDPixelFormat::FGetSize()
{
return sizeof(DDPIXELFORMAT);
}

// --------------------------------------------------------------------------
// Method:          FSetSize                                                    //added set
// Description:     This sets the size of the internal DDPIXELFORMAT
//                  structure
// --------------------------------------------------------------------------
void               __fastcall  TDDPixelFormat::FSetSize( dword pSize )
{
return;
}

// --------------------------------------------------------------------------
// Method:          FGetUBitMask
// Description:     Returns mask for U bits
//---------------------------------------------------------------------------
dword               __fastcall  TDDPixelFormat::FGetUBitMask()
{
return fPixelFormat.dwUBitMask;
}

// --------------------------------------------------------------------------
// Method:          FSetUBitMask
// Description:     Sets mask for U bits
//---------------------------------------------------------------------------
void                __fastcall  TDDPixelFormat::FSetUBitMask( dword
                                                                ubitmask )
{
fPixelFormat.dwUBitMask = ubitmask;
}

// --------------------------------------------------------------------------
// Method:          FGetVBitMask
// Description:     Returns the mask for V bits
//---------------------------------------------------------------------------
dword               __fastcall  TDDPixelFormat::FGetVBitMask()
{
return fPixelFormat.dwVBitMask;
}

// --------------------------------------------------------------------------
// Method:          FSetVBitMask
// Description:     Sets the mask for V bits
//---------------------------------------------------------------------------
void                __fastcall  TDDPixelFormat::FSetVBitMask( dword
                                                                vbitmask )
{
fPixelFormat.dwVBitMask = vbitmask;
}

// --------------------------------------------------------------------------
// Method:          FGetYBitMask
// Description:     Returns the mask for Y bits
//---------------------------------------------------------------------------
dword               __fastcall  TDDPixelFormat::FGetYBitMask()
{
return fPixelFormat.dwYBitMask;
}

// --------------------------------------------------------------------------
// Method:          FSetYBitMask
// Description:     Sets the mask for Y bits
//---------------------------------------------------------------------------
void                __fastcall  TDDPixelFormat::FSetYBitMask( dword
                                                                ybitmask )
{
fPixelFormat.dwYBitMask = ybitmask;
}

// --------------------------------------------------------------------------
// Method:          FGetYUVAlphaBitMask
// Description:     Returns the mask for the alpha channel
//---------------------------------------------------------------------------
dword               __fastcall  TDDPixelFormat::FGetYUVAlphaBitMask()
{
return fPixelFormat.dwYUVAlphaBitMask;
}

// --------------------------------------------------------------------------
// Method:          FSetYUVAlphaBitMask
// Description:     Sets the mask for alpha channel
//---------------------------------------------------------------------------
void                __fastcall  TDDPixelFormat::FSetYUVAlphaBitMask( dword
                                                            yuvalphabitmask )
{
fPixelFormat.dwYUVAlphaBitMask = yuvalphabitmask;
}

// --------------------------------------------------------------------------
// Method:          FGetYUVBitCount
// Description:     Returns YUV bits per pixel
// Note:            4, 8, 16, 24 or 32
//---------------------------------------------------------------------------
dword               __fastcall  TDDPixelFormat::FGetYUVBitCount()
{
return fPixelFormat.dwYUVBitCount;
}

// --------------------------------------------------------------------------
// Method:          FSetYUVBitCount
// Description:     Sets YUV bits per pixel
// Note:            4, 8, 16, 24 or 32
//---------------------------------------------------------------------------
void                __fastcall  TDDPixelFormat::FSetYUVBitCount( dword
                                                                yuvbitcount )
{
fPixelFormat.dwYUVBitCount = yuvbitcount;
}

// --------------------------------------------------------------------------
// Method:          FGetYUVZBitMask
// Description:     Returns the mask for the Z channel
//---------------------------------------------------------------------------
dword       __fastcall  TDDPixelFormat::FGetYUVZBitMask()
{
return fPixelFormat.dwYUVZBitMask;
}

// --------------------------------------------------------------------------
// Method:          FSetYUVZBitMask
// Description:     Sets the mask for the Z channel
//---------------------------------------------------------------------------
void                __fastcall  TDDPixelFormat::FSetYUVZBitMask( dword yuvzbitmask )
{
fPixelFormat.dwYUVZBitMask = yuvzbitmask;
}

// --------------------------------------------------------------------------
// Method:          FGetZBufferBitDepth
// Description:     Returns Z-buffer bit depth
// Note:            8, 16 or 24. 32-bit z-buffers are not supported
//---------------------------------------------------------------------------
dword               __fastcall  TDDPixelFormat::FGetZBufferBitDepth()
{
return fPixelFormat.dwZBufferBitDepth;
}

// --------------------------------------------------------------------------
// Method:          FSetZBufferBitDepth
// Description:     Sets Z-buffer bit depth
// Note:            8, 16 or 24. 32-bit z-buffers are not supported
//---------------------------------------------------------------------------
void                __fastcall  TDDPixelFormat::FSetZBufferBitDepth( dword
                                                            zbufferbitdepth )
{
fPixelFormat.dwZBufferBitDepth = zbufferbitdepth;
}

// --------------------------------------------------------------------------

