//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

// ==========================================================================
// File:            TDDSCaps.CPP
// Description:
//
// (c) 1998 A.S.C. Alternate Software Concepts, Sydney, Australia.
// All Rights Reserved. Refer to the file TDirectX_Licence.Txt for detailed
// licence & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// include the TDDBltBatch H file.
// --------------------------------------------------------------------------
#include "TDDSCaps.h"

// ==========================================================================
// Class:           TDDSCaps
// Description:     This is a component that wraps the DDSCAPS structure
//                  available within DirectX5.
// Notes:           Properties - Caps, Size
// ==========================================================================

// --------------------------------------------------------------------------
// Constructor
// --------------------------------------------------------------------------
                    __fastcall  TDDSCaps::TDDSCaps() : TPersistent()
{
fCaps.dwCaps = 0;
}

// --------------------------------------------------------------------------
// Destructor
//---------------------------------------------------------------------------
                    __fastcall  TDDSCaps::~TDDSCaps()
{
}

// --------------------------------------------------------------------------
// Method:          Ptr
// Description:     This method returns a pointer to the internal DDSCAPS
//                  structure.
//---------------------------------------------------------------------------
DDSCAPS*            __fastcall  TDDSCaps::Ptr()
{
return &fCaps;
}

// --------------------------------------------------------------------------
// Method:          FGetCaps
// Description:     Returns current capabilities of a surface
//---------------------------------------------------------------------------
dword               __fastcall  TDDSCaps::FGetCaps()
{
return fCaps.dwCaps;
}

// --------------------------------------------------------------------------
// Method:          FSetCaps
// Description:     Sets capabilities of a surface
//---------------------------------------------------------------------------
void                __fastcall  TDDSCaps::FSetCaps( dword caps )
{
fCaps.dwCaps = caps;
}

// --------------------------------------------------------------------------
// Method:          FGetSize
// Description:     This returns the size of the internal DDSCAPS structure.
//---------------------------------------------------------------------------
dword               __fastcall  TDDSCaps::FGetSize()
{
return sizeof(DDSCAPS);
}

// --------------------------------------------------------------------------
// Method:          FSetSize                                                    //added set
// Description:     Sets the size of the internal DDSCAPS structure.
//---------------------------------------------------------------------------
void                __fastcall  TDDSCaps::FSetSize( dword pSize)
{
return;
}

// --------------------------------------------------------------------------
// Method:          To_TDDSCapsCapsString
// Description:     Converts to TDX5 bitwise flags from BCB sets
//---------------------------------------------------------------------------
AnsiString          __fastcall  To_TDDSCapsCapsString( dword pCaps )
{
AnsiString str = "[";
if (pCaps & DDSCAPS_3DDEVICE) str = str + "DDSCAPS_3DDEVICE,";
if (pCaps & DDSCAPS_ALLOCONLOAD) str = str + "DDSCAPS_ALLOCONLOAD,";
if (pCaps & DDSCAPS_ALPHA) str = str + "DDSCAPS_ALPHA,";
if (pCaps & DDSCAPS_BACKBUFFER) str = str + "DDSCAPS_BACKBUFFER,";
if (pCaps & DDSCAPS_COMPLEX) str = str + "DDSCAPS_COMPLEX,";
if (pCaps & DDSCAPS_FLIP) str = str + "DDSCAPS_FLIP,";
if (pCaps & DDSCAPS_FRONTBUFFER) str = str + "DDSCAPS_FRONTBUFFER,";
if (pCaps & DDSCAPS_HWCODEC) str = str + "DDSCAPS_HWCODEC,";
if (pCaps & DDSCAPS_LIVEVIDEO) str = str + "DDSCAPS_LIVEVIDEO,";
if (pCaps & DDSCAPS_LOCALVIDMEM) str = str + "DDSCAPS_LOCALVIDMEM,";
if (pCaps & DDSCAPS_MIPMAP) str = str + "DDSCAPS_MIPMAP,";
if (pCaps & DDSCAPS_MODEX) str = str + "DDSCAPS_MODEX,";
if (pCaps & DDSCAPS_NONLOCALVIDMEM) str = str + "DDSCAPS_NONLOCALVIDMEM,";
if (pCaps & DDSCAPS_OFFSCREENPLAIN) str = str + "DDSCAPS_OFFSCREENPLAIN,";
if (pCaps & DDSCAPS_OVERLAY) str = str + "DDSCAPS_OVERLAY,";
if (pCaps & DDSCAPS_OWNDC) str = str + "DDSCAPS_OWNDC,";
if (pCaps & DDSCAPS_PALETTE) str = str + "DDSCAPS_PALETTE,";
if (pCaps & DDSCAPS_PRIMARYSURFACE) str = str + "DDSCAPS_PRIMARYSURFACE,";
if (pCaps & DDSCAPS_PRIMARYSURFACELEFT) str = str +
                                            "DDSCAPS_PRIMARYSURFACELEFT,";
if (pCaps & DDSCAPS_STANDARDVGAMODE) str = str + "DDSCAPS_STANDARDVGAMODE,";
if (pCaps & DDSCAPS_SYSTEMMEMORY) str = str + "DDSCAPS_SYSTEMMEMORY,";
if (pCaps & DDSCAPS_TEXTURE) str = str + "DDSCAPS_TEXTURE,";
if (pCaps & DDSCAPS_VIDEOMEMORY) str = str + "DDSCAPS_VIDEOMEMORY,";
if (pCaps & DDSCAPS_VIDEOPORT) str = str + "DDSCAPS_VIDEOPORT,";
if (pCaps & DDSCAPS_VISIBLE) str = str + "DDSCAPS_VISIBLE,";
if (pCaps & DDSCAPS_WRITEONLY) str = str + "DDSCAPS_WRITEONLY,";
if (pCaps & DDSCAPS_ZBUFFER) str = str + "DDSCAPS_ZBUFFER,";
if (str.Length() > 1) str.SetLength( str.Length()-1 );
str = str + "]";
return str;
}

// --------------------------------------------------------------------------
// Method:          From_TDDSCapsCapsString
// Description:     Converts from TDX5 bitwise flags to BCB sets
//---------------------------------------------------------------------------
dword               __fastcall  From_TDDSCapsCapsString( AnsiString pStr )
{
dword caps = 0;
if (pStr.Pos("DDSCAPS_3DDEVICE")!=0) caps |= DDSCAPS_3DDEVICE;
if (pStr.Pos("DDSCAPS_ALLOCONLOAD")!=0) caps |= DDSCAPS_3DDEVICE;
if (pStr.Pos("DDSCAPS_ALPHA")!=0) caps |= DDSCAPS_3DDEVICE;
if (pStr.Pos("DDSCAPS_BACKBUFFER")!=0) caps |= DDSCAPS_3DDEVICE;
if (pStr.Pos("DDSCAPS_COMPLEX")!=0) caps |= DDSCAPS_3DDEVICE;
if (pStr.Pos("DDSCAPS_FLIP")!=0) caps |= DDSCAPS_3DDEVICE;
if (pStr.Pos("DDSCAPS_FRONTBUFFER")!=0) caps |= DDSCAPS_3DDEVICE;
if (pStr.Pos("DDSCAPS_HWCODEC")!=0) caps |= DDSCAPS_3DDEVICE;
if (pStr.Pos("DDSCAPS_LIVEVIDEO")!=0) caps |= DDSCAPS_3DDEVICE;
if (pStr.Pos("DDSCAPS_LOCALVIDMEM")!=0) caps |= DDSCAPS_3DDEVICE;
if (pStr.Pos("DDSCAPS_MIPMAP")!=0) caps |= DDSCAPS_3DDEVICE;
if (pStr.Pos("DDSCAPS_MODEX")!=0) caps |= DDSCAPS_3DDEVICE;
if (pStr.Pos("DDSCAPS_NONLOCALVIDMEM")!=0) caps |= DDSCAPS_3DDEVICE;
if (pStr.Pos("DDSCAPS_OFFSCREENPLAIN")!=0) caps |= DDSCAPS_3DDEVICE;
if (pStr.Pos("DDSCAPS_OVERLAY")!=0) caps |= DDSCAPS_3DDEVICE;
if (pStr.Pos("DDSCAPS_OWNDC")!=0) caps |= DDSCAPS_3DDEVICE;
if (pStr.Pos("DDSCAPS_PALETTE")!=0) caps |= DDSCAPS_3DDEVICE;
if (pStr.Pos("DDSCAPS_PRIMARYSURFACE")!=0) caps |= DDSCAPS_3DDEVICE;
if (pStr.Pos("DDSCAPS_PRIMARYSURFACELEFT")!=0) caps |= DDSCAPS_3DDEVICE;
if (pStr.Pos("DDSCAPS_STANDARDVGAMODE")!=0) caps |= DDSCAPS_3DDEVICE;
if (pStr.Pos("DDSCAPS_SYSTEMMEMORY")!=0) caps |= DDSCAPS_3DDEVICE;
if (pStr.Pos("DDSCAPS_TEXTURE")!=0) caps |= DDSCAPS_3DDEVICE;
if (pStr.Pos("DDSCAPS_VIDEOMEMORY")!=0) caps |= DDSCAPS_3DDEVICE;
if (pStr.Pos("DDSCAPS_VIDEOPORT")!=0) caps |= DDSCAPS_3DDEVICE;
if (pStr.Pos("DDSCAPS_VISIBLE")!=0) caps |= DDSCAPS_3DDEVICE;
if (pStr.Pos("DDSCAPS_WRITEONLY")!=0) caps |= DDSCAPS_3DDEVICE;
if (pStr.Pos("DDSCAPS_ZBUFFER")!=0) caps |= DDSCAPS_3DDEVICE;
return caps;
}

