//---------------------------------------------------------------------------
#ifndef TDDSCapsH
#define TDDSCapsH

// ==========================================================================
// File:            TDDSCaps.H
// Description:
//
// (c) 1998 A.S.C. Alternate Software Concepts, Sydney, Australia.
// All Rights Reserved. Refer to the file TDirectX_Licence.Txt for detailed
// licence & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// include the basic TDirectDraw definitions, etc.
// --------------------------------------------------------------------------
#include "TDirectDrawInclude.h"
#include "TDirectDrawDefs.h"
#include "TDirectDrawErrors.h"
#include "TDirectDrawMisc.h"

// ==========================================================================
// Class:           TDDSCaps
// Description:     This is a component that wraps the DDSCAPS structure
//                  available within DirectX5.
// Notes:           Properties - Caps, Size
// ==========================================================================
class TDDSCaps : public TPersistent
{
__published:
public:

// --------------------------------------------------------------------------
// Property:        Caps
// Description:     Capabilities of the surface.
// --------------------------------------------------------------------------
    __property      dword                      Caps = { read=FGetCaps,
                                                        write=FSetCaps,
                                                        nodefault };

// --------------------------------------------------------------------------
// Property:        Size
// Description:     This contains the size of the internal DDSCAPS
//                  structure.
// --------------------------------------------------------------------------
    __property      dword                      Size = { read=FGetSize,
                                                        write=FSetSize,         //added set, nodefault
                                                        nodefault };

// --------------------------------------------------------------------------
// Constructor & Destructor
// --------------------------------------------------------------------------
                    __fastcall  TDDSCaps();
    virtual         __fastcall   ~TDDSCaps();

// --------------------------------------------------------------------------
// Method:          Ptr
// Description:     This property returns a pointer to the internal
//                  DDSCAPS structure.
// --------------------------------------------------------------------------
    DDSCAPS*        __fastcall  Ptr();

// --------------------------------------------------------------------------
// End of the TDDBltBatch wrapper
// --------------------------------------------------------------------------

protected:

    dword           __fastcall  FGetCaps();
    void            __fastcall  FSetCaps( dword caps );
    dword           __fastcall  FGetSize();
    void            __fastcall  FSetSize( dword pSize );                        //added set

private:

    DDSCAPS         fCaps;
};
//---------------------------------------------------------------------------
AnsiString          __fastcall  To_TDDSCapsCapsString( dword pCaps );
dword               __fastcall  From_TDDSCapsCapsString( AnsiString pStr );
//---------------------------------------------------------------------------
#endif
