//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

// ==========================================================================
// File:            TDDVideoPortBandwidth.CPP
// Description:
//
// (c) 1998 A.S.C. Alternate Software Concepts, Sydney, Australia.
// All Rights Reserved. Refer to the file TDirectX_Licence.Txt for detailed
// licence & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// include the TDDVideoPortBandwidth H file.
// --------------------------------------------------------------------------
#include "TDDVideoPortBandwidth.h"

// ==========================================================================
// Class:           TDDVideoPortBandwidth
// Description:     The TDDVideoPortBandwidth object describes the bandwidth
//                  characteristics of an overlay surface when used with a
//                  particular video port and pixel format configuration
// Note:            This object is used with the
//                  TDirectDrawVideoPort::GetBandwidthInfo method
// ==========================================================================

// --------------------------------------------------------------------------
// Constructor
// --------------------------------------------------------------------------
                    __fastcall  TDDVideoPortBandwidth::
                                    TDDVideoPortBandwidth() : TPersistent()
{
fVideoPortBandwidth.dwSize = sizeof(DDVIDEOPORTBANDWIDTH);
}

// --------------------------------------------------------------------------
// Destructor
// --------------------------------------------------------------------------
                    __fastcall  TDDVideoPortBandwidth::
                                                    ~TDDVideoPortBandwidth()
{
}

// --------------------------------------------------------------------------
// Method:          Ptr
// Description:     This method returns a pointer to the internal
//                  DDVIDEOPORTBANDWIDTH structure.
// --------------------------------------------------------------------------
DDVIDEOPORTBANDWIDTH* __fastcall TDDVideoPortBandwidth::Ptr()
{
return &fVideoPortBandwidth;
}

// --------------------------------------------------------------------------
// Method:          FGetCaps
// Description:     Returns the flag values specifying device dependency
// Note:            This member can be one of TDDVideoPortBandwidthCaps
//                  values
// --------------------------------------------------------------------------
dword               __fastcall  TDDVideoPortBandwidth::FGetCaps()
{
return fVideoPortBandwidth.dwCaps;
}

// --------------------------------------------------------------------------
// Method:          FSetCaps
// Description:     Sets the flag values specifying device dependency
// Note:            This member can be one of TDDVideoPortBandwidthCaps
//                  values
// --------------------------------------------------------------------------
void                __fastcall  TDDVideoPortBandwidth::FSetCaps( dword caps )
{
fVideoPortBandwidth.dwCaps = caps;
}

// --------------------------------------------------------------------------
// Method:          FGetColorKey
// Description:     Returns the stretch factor or overlay source size at
//                  which an overlay with color keying is supported
//                  multiplied by 1000
// Note:            Example 1.3 = 1300, or .75 = 750
// --------------------------------------------------------------------------
dword               __fastcall  TDDVideoPortBandwidth::FGetColorKey()
{
return fVideoPortBandwidth.dwColorkey;
}

// --------------------------------------------------------------------------
// Method:          FSetColorKey
// Description:     Sets the stretch factor or overlay source size at which
//                  an overlay with color keying is supported multiplied by
//                  1000
// Note:            Example 1.3 = 1300, or .75 = 750
// --------------------------------------------------------------------------
void                __fastcall  TDDVideoPortBandwidth::FSetColorKey( dword
                                                                colorkey )
{
fVideoPortBandwidth.dwColorkey = colorkey;
}

// --------------------------------------------------------------------------
// Method:          FGetOverlay
// Description:     Returns the stretch factor or overlay source size at
//                  which an overlay is supported multiplied by 1000
// Note:            Example 1.3 = 1300, or .75 = 750
// --------------------------------------------------------------------------
dword               __fastcall  TDDVideoPortBandwidth::FGetOverlay()
{
return fVideoPortBandwidth.dwOverlay;
}

// --------------------------------------------------------------------------
// Method:          FSetOverlay
// Description:     Sets the stretch factor or overlay source size at which
//                  an overlay is supported multiplied by 1000.
// Note:            Example 1.3 = 1300, or .75 = 750
// --------------------------------------------------------------------------
void                __fastcall  TDDVideoPortBandwidth::FSetOverlay( dword
                                                                    overlay )
{
fVideoPortBandwidth.dwOverlay = overlay;
}

// --------------------------------------------------------------------------
// Method:          FGetSize
// Description:     This returns the size of the internal
//                  DDVIDEOPORTBANDWIDTH structure
// --------------------------------------------------------------------------
dword               __fastcall  TDDVideoPortBandwidth::FGetSize()
{
return sizeof(DDVIDEOPORTBANDWIDTH);
}

// --------------------------------------------------------------------------
// Method:          FSetSize                                                    //added set
// Description:     This sets the size of the internal
//                  DDVIDEOPORTBANDWIDTH structure.
// --------------------------------------------------------------------------
void               __fastcall  TDDVideoPortBandwidth::FSetSize( dword pSize )
{
return;
}

// --------------------------------------------------------------------------
// Method:          FGetYInterpAndColorKey
// Description:     Returns the stretch factor or overlay source size at
//                  which an overlay with Y-axis interpolation and color
//                  keying is supported multiplied by 1000
// Note:            Example 1.3 = 1300, or .75 = 750
// --------------------------------------------------------------------------
dword               __fastcall  TDDVideoPortBandwidth::
                                                    FGetYInterpAndColorKey()
{
return fVideoPortBandwidth.dwYInterpAndColorkey;
}

// --------------------------------------------------------------------------
// Method:          FSetYInterpAndColorKey
// Description:     Sets the stretch factor or overlay source size at which
//                  an overlay with Y-axis interpolation and color keying is
//                  supported multiplied by 1000
// Note:            Example 1.3 = 1300, or .75 = 750
// --------------------------------------------------------------------------
void                __fastcall  TDDVideoPortBandwidth::FSetYInterpAndColorKey
                                                ( dword yinterpandcolorkey )
{
fVideoPortBandwidth.dwYInterpAndColorkey = yinterpandcolorkey;
}
// --------------------------------------------------------------------------
// Method:          FGetYInterpolate
// Description:     Returns the sstretch factor or overlay source size at
//                  which an overlay with Y-axis interpolation is supported
//                  multiplied by 1000
// Note:            Example 1.3 = 1300, or .75 = 750
// --------------------------------------------------------------------------
dword               __fastcall  TDDVideoPortBandwidth::FGetYInterpolate()
{
return fVideoPortBandwidth.dwYInterpolate;
}

// --------------------------------------------------------------------------
// Method:          FSetYInterpolate
// Description:     Sets the stretch factor or overlay source size at which
//                  an overlay with Y-axis interpolation is supported
//                  multiplied by 1000
// Note:            Example 1.3 = 1300, or .75 = 750
// --------------------------------------------------------------------------
void                __fastcall  TDDVideoPortBandwidth::FSetYInterpolate(
                                                        dword yinterpolate )
{
fVideoPortBandwidth.dwYInterpolate = yinterpolate;
}

// --------------------------------------------------------------------------
